package com.connor.jd.plm.action;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.connor.jd.plm.utils.JDMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.common.Activator;
import com.teamcenter.rac.kernel.TCAccessControlService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.util.MessageBox;

public class WLTZReviseAction extends AbstractAIFAction {
	private AbstractAIFApplication app;
	private TCSession session;

	public WLTZReviseAction(AbstractAIFApplication arg0, String arg1) {
		super(arg0, arg1);
		this.app = arg0;
		this.session = (TCSession) app.getSession();
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		String server = JDMethodUtil.getPrefStr("jd2_server_ip", session);
		if (server == null || "".equals(server)) {
			MessageBox.post("δjd2_server_ipѡ", "", MessageBox.ERROR);
			return;
		}

		TCComponent target = (TCComponent) AIFUtility.getCurrentApplication().getTargetComponent();
		String[] allow = getPrefStrArray("jd2_wltz_Revise_allow");
		List<String> list = Arrays.asList(allow);
		for (String s : list) {
			System.out.println(s);
		}
		TCAccessControlService aclService = session.getTCAccessControlService();
		TCComponentItemRevision rev;
		if (target instanceof TCComponentItemRevision) {
			rev = (TCComponentItemRevision) target;
		} else if (target instanceof TCComponentBOMLine) {
			try {
				rev = ((TCComponentBOMLine) target).getItemRevision();
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				MessageBox.post(e.getMessage(), "", MessageBox.ERROR);
				return;
			}
		} else {
			MessageBox.post("ǰͲ޶ͷ࣡", "", MessageBox.ERROR);
			return;
		}
		try {
			String type = rev.getType();
			System.out.println("uid===>" + rev.getItem().getUid());
			System.out.println("user===>" + session.getUser().getUid());
			System.out.println(type);
			if (!list.contains(type)) {
				MessageBox.post("ǰͲ޶ͷ࣡", "", MessageBox.ERROR);
				return;
			}
			rev.refresh();
//			String url = "http://" + server + ":8880/api/grantPrivilege";
//			TCComponentItem item = rev.getItem();
//			TCComponent[] comps = rev.getRelatedComponents("fnd0ActuatedInteractiveTsks");
//			TCComponent[] bomViews = item.getRelatedComponents("bom_view_tags");
//			String uids = "";
//			for (TCComponent bomView : bomViews) {
//				uids += "," + bomView.getUid();
//			}
//			AIFComponentContext[] referenced = rev.whereReferenced();
//			for (AIFComponentContext aif : referenced) {
//				if (aif.getComponent() instanceof TCComponentItem
//						|| aif.getComponent() instanceof TCComponentItemRevision) {
//					uids += aif.getComponent().getUid() + ",";
//				}
//			}
//			uids = uids.substring(0, uids.length() - 1);
//			Map<String, Object> privilegeMap = new HashMap<String, Object>();
//			privilegeMap.put("uid", uids);
//			privilegeMap.put("user", session.getUser().getUid());
//			privilegeMap.put("privilege", "WRITE,DELETE");
//			privilegeMap.put("pass", true);
//			List<String> allow2 = Arrays.asList(JDMethodUtil.getPrefStrArray("jd_wltz_revise_workflow", session));
//			System.out.println("allow workflow:" + Arrays.toString(allow2.toArray()));
//			TCComponentItemRevision newRev = null;
//			boolean getPrivilege = false;
//			for (TCComponent comp : comps) {
//				if (comp.getProperty("object_name").contains("") && allow2.contains(comp.getProperty("parent_name"))
//						&& comp.getProperty("task_state").equals("ѿʼ")) {
//					System.out.println("ʼȨ");
//					privilegeMap.put("pass", true);
//					String res = HttpUtil.post(url, privilegeMap);
//					System.out.println("res===>" + res);
//					if (!res.contains("success")) {
//						MessageBox.post("Ȩ쳣ʧ", "", MessageBox.ERROR);
//						return;
//					}
//					item.refresh();
//					for (TCComponent bomView : bomViews) {
//						bomView.refresh();
//					}
//					getPrivilege = true;
//					System.out.println("Ȩдɾ");
//					session.getUserService().call("bs_bypass", new Object[] { true });
//					newRev = rev.saveAs(item.getNewRev());
//					session.getUserService().call("bs_bypass", new Object[] { false });
//					break;
//				}
//			}
//			boolean isAccess = session.getTCAccessControlService().checkPrivilege(rev.getItem(), "WRITE");
//			if (!isAccess) {
//				MessageBox.post("Ȩ", "ʾ", MessageBox.WARNING);
//				return;
//			}
			String loginUser = session.getUser().getProperty("object_string");
			String owningUser = rev.getProperty("owning_user");
			System.out.println("loginUser===>" + loginUser);
			System.out.println("owningUser===>" + owningUser);
			TCComponentItemRevision newRev = null;
			if (!loginUser.equals(owningUser)) {
				System.out.println("̣");
				MessageBox.post("̣", "ʾ", MessageBox.WARNING);
				return;
			} else {
				session.getUserService().call("bs_bypass", new Object[] { true });
				newRev = rev.saveAs(rev.getItem().getNewRev());
				if (target instanceof TCComponentBOMLine) {
					TCComponentBOMLine bomLine = (TCComponentBOMLine) target;
					if (bomLine.parent() != null) {
						bomLine.window().refresh();
					} else {
						System.out.println("topLine");
						Activator.getDefault().openPerspective("com.teamcenter.rac.pse.PSEPerspective");
						Activator.getDefault().openComponents("com.teamcenter.rac.pse.PSEPerspective",
								new InterfaceAIFComponent[] { newRev });
					}
				}
				session.getUserService().call("bs_bypass", new Object[] { false });
			}
			if (rev.getClassificationClass() == null || "".equals(rev.getClassificationClass())) {
				MessageBox.post("ɹ", "ʾ", MessageBox.WARNING);
//				if (getPrivilege) {
//					privilegeMap.put("pass", false);
//					String res = HttpUtil.post(url, privilegeMap);
//					System.out.println("res===>" + res);
//					if (res.contains("error")) {
//						MessageBox.post("Ȩ쳣ʧ", "", MessageBox.ERROR);
//						return;
//					}
//					item.refresh();
//					for (TCComponent bomView : bomViews) {
//						bomView.refresh();
//					}
//					System.out.println("ѳдɾȨ");
//				}
				System.out.println("success");
				return;
			}
			if (newRev == null) {
				MessageBox.post("δ֪쳣", "", MessageBox.ERROR);
				return;
			}
			TCComponentICO ico = rev.getClassificationObjects()[0];
			ICSProperty[] oldICSProps = ico.getICSProperties(true);
			int[] ids = new int[oldICSProps.length];
			String[] values = new String[oldICSProps.length];
			for (int i = 0; i < oldICSProps.length; i++) {
				System.out.println(oldICSProps[i].getId() + "=====>" + oldICSProps[i].getValue());
				ids[i] = oldICSProps[i].getId();
				values[i] = oldICSProps[i].getValue();
			}
			JSONObject json = new JSONObject();
			json.put("ids", ids);
			json.put("values", values);
			String prop = json.toString();
//			prop = prop.replace("\"", "\\\"");
			System.out.println("prop:" + prop);
			String uid = newRev.getUid();
			System.out.println("uid:" + uid);
			String cid = rev.getClassificationClass();
			System.out.println("cid:" + cid);
			Map<String, Object> paramMap = new HashMap<String, Object>();
			paramMap.put("uid", uid);
			paramMap.put("cid", cid);
			paramMap.put("prop", prop);
			final String URL = "http://" + server + ":8880/api/sendClassification";
//			final String URL2 = url;
			final Map<String, Object> PARAMMAP = paramMap;
//			final Map<String, Object> PRIVILEGEMAP = privilegeMap;
//			final TCComponent[] BOMVIEWS = bomViews;
//			final boolean GetPrivilege = getPrivilege;
			new Thread(new Runnable() {

				@Override
				public void run() {
					// TODO Auto-generated method stub
					cn.hutool.http.HttpUtil.post(URL, PARAMMAP);
					MessageBox.post("ɹ", "ʾ", MessageBox.WARNING);

//					if (GetPrivilege) {
//						PRIVILEGEMAP.put("pass", false);
//						String res = HttpUtil.post(URL2, PRIVILEGEMAP);
//						System.out.println("res===>" + res);
//						if (!res.contains("success")) {
//							MessageBox.post("Ȩ쳣ʧ", "", MessageBox.ERROR);
//						} else {
//							try {
//								item.refresh();
//								for (TCComponent bomView : BOMVIEWS) {
//									bomView.refresh();
//								}
//							} catch (TCException e) {
//								// TODO Auto-generated catch block
//								e.printStackTrace();
//							}
//						System.out.println("ѳдɾȨ");
//					}
//					}

					System.out.println("success");
				}
			}).start();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			MessageBox.post(e.getMessage(), "", MessageBox.ERROR);
		}
	}

	/**
	 * ȡֵѡ
	 * 
	 * @param prefName
	 * @return
	 */
	public String getPrefStr(String prefName) {
		TCPreferenceService service = session.getPreferenceService();
		String str = service.getString(TCPreferenceService.TC_preference_site, prefName);
		if (str == null) {
			str = new String("");
		}
		return str;
	}

	/**
	 * ȡֵѡ
	 * 
	 * @param prefName
	 * @return
	 */
	public String[] getPrefStrArray(String prefName) {
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringArray(TCPreferenceService.TC_preference_site, prefName);
		service.getStringValues(prefName);
		service.getStringValue(prefName);
		if (strs == null) {
			strs = new String[] { "" };
		}
		return strs;
	}

}
