package com.connor.jd.plm.changeImportObjectsUnit;

import java.awt.Frame;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aif.kernel.AbstractAIFSession;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCTextService;
import com.teamcenter.rac.util.MessageBox;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ChangeImportObjectsUnitAction extends AbstractAIFAction {
	
	private AbstractAIFApplication application;

//	/**
//	 * objectsUnitMap洢item_id͵λ
//	 * key Ϊitem_id
//	 * valueΪλ
//	 */
//	private Map<String, String> objectsUnitMap = new HashMap<>();
	
	/*
	 * columList洢item_idλ汾
	 */
	private List<List<String>> columList = new ArrayList<List<String>>();
	

	public ChangeImportObjectsUnitAction(AbstractAIFApplication application, Frame frame, String param) {
		super(application, frame, param);
		this.application = application;
		// TODO ԶɵĹ캯
	}

	@Override
	public void run() {
		// ļѡ
		JFileChooser fileChooser = new JFileChooser();
		// ļֻʾXLSXļ
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Excel Files", "xlsx");
		fileChooser.setFileFilter(filter);

		// ʾļѡԻ
		int result = fileChooser.showOpenDialog(null);
		if (result == JFileChooser.APPROVE_OPTION) {
			// ȡѡеļ
			File selectedFile = fileChooser.getSelectedFile();
			try (FileInputStream fis = new FileInputStream(selectedFile);
				 Workbook workbook = new XSSFWorkbook(fis)) {
				// ȡһ
				Sheet sheet = workbook.getSheetAt(0);
				if (sheet != null){
					try {
						getChangeUnitInfo(sheet);
					} catch (Exception e) {
						System.out.println("ȡ쳣\n"+e.getMessage());
						e.printStackTrace();
					}
					setObjectsUnit(columList);
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}



	}

	private void setObjectsUnit(List<List<String>> columList2) {
		AbstractAIFSession session = this.application.getSession();
		TCSession tcSession = (TCSession)session;
		if (columList2.size() <= 0) {
			System.out.println("δȡЧitem_id͵λֵ");
			return;
		}
//		//mapеitem_idʹ޸ĵĵλֵ
//		for (String key : columList2.keySet()){
//			String unit = columList2.get(key);//λ
//			
//			try {
//				TCComponent[] searchs = tcSession.search("...", 
//						new String[] { "item_id" },
//						new String[] { key });
//				
//				if (searchs.length<0) {
//					System.out.println("erroitem_id["+key+"]δѯض");
//					continue;
//				}
//				
//				TCComponent tcComponent = searchs[0];
//				tcComponent.setProperty("uom_tag", unit == null ? "" : unit);
//				
//			}catch (Exception e){
//				String erroMSGString = "item_id="+key+";\n"+"λ="+unit+";\nϢ\n"+e.getMessage();
//				MessageBox.post(erroMSGString , "õλ쳣", MessageBox.ERROR);
//				e.printStackTrace();
//			};
//		}
		
		for (int i = 0; i < columList2.size(); i++) {
			List<String> keyList = columList2.get(i);//xlsxеһеid汾λ
			String itemId = keyList.get(0);
			String unit = keyList.get(1);
			String rev = keyList.get(2);
			try {
				TCComponent[] searchs = tcSession.search("...", 
						new String[] { "item_id" },
						new String[] { itemId });
				
				if (searchs.length<0) {
					System.out.println("erroitem_id["+itemId+"]δѯض");
					continue;
				}
				
				TCComponent tcComponent = searchs[0];
				tcComponent.setProperty("uom_tag", unit == null ? "" : unit);
				tcComponent.refresh();
				
				System.out.println("["+tcComponent.getStringProperty("object_string")+"]µλɣ");
				
				
			}catch (Exception e){
				String erroMSGString = "item_id="+itemId+";\n"+"λ="+unit+";\nϢ\n"+e.getMessage();
				MessageBox.post(erroMSGString , "õλ쳣", MessageBox.ERROR);
				e.printStackTrace();
			};
			
		}
		MessageBox.post("λɣ" , "ʾ", MessageBox.INFORMATION);
	}

	/**
	 * ݱݣлȡؼϢҪitemIdλ汾ŵcolumList
	 * @author kuma
	 * @param sheet
	 * 
	 */
	private void getChangeUnitInfo(Sheet sheet) {
		//¼item_id͵λı
		int itemIdColumnIndex = 0;
		int unitColumnIndex = -1;
		int revColumnIndex = -1;

		// ȡһУͷ
		Row headerRow = sheet.getRow(0);
		if (headerRow == null){
			MessageBox.post("Ϊ!" , "ļ쳣", MessageBox.ERROR);
			return;
		}
		
		for (Cell cell : headerRow) {
			if (cell != null && "λ".equals(getCellValue(cell))) {
				unitColumnIndex = cell.getColumnIndex();
				break;
			}
		}
		if (unitColumnIndex == -1){
			MessageBox.post("δҵ'λ'ͷ!" , "ļ쳣", MessageBox.ERROR);
			return;
		}
		for (Cell cell : headerRow) {
			if (cell != null && "汾".equals(getCellValue(cell))) {
				revColumnIndex = cell.getColumnIndex();
				break;
			}
		}
		if (revColumnIndex == -1){
			MessageBox.post("δҵ'汾'ͷ!" , "ļ쳣", MessageBox.ERROR);
			return;
		}

		// ÿһ
		for (int i = 1; i <= sheet.getLastRowNum(); i++){
			
			Row row = sheet.getRow(i);
			if (row != null){
				Cell itemIdCell = row.getCell(itemIdColumnIndex);
				Cell unitCell = row.getCell(unitColumnIndex);
				Cell revCell = row.getCell(revColumnIndex);
				if (itemIdCell != null && unitCell != null && revCell != null){
					List<String> layerList = new ArrayList<String>();
					String itemId = getCellValue(itemIdCell);
					String unit = getCellValue(unitCell);
					String rev = getCellValue(revCell);
//					objectsUnitMap.put(itemId, unit);
					layerList.add(itemId == null ? "" : itemId);
					layerList.add(unit == null ? "" : unit);
					layerList.add(rev == null ? "" : rev);
					columList.add(layerList);
				}
			}
		}
		
	}



	private String getCellValue(Cell cell) {
//		switch (cell.getCellType()) {
//			case STRING:
//				return cell.getStringCellValue();
//			case NUMERIC:
//				if (DateUtil.isCellDateFormatted(cell)) {
//					return cell.getDateCellValue().toString();
//				} else {
//					return String.valueOf(cell.getNumericCellValue());
//				}
//			case BOOLEAN:
//				return String.valueOf(cell.getBooleanCellValue());
//			case FORMULA:
//				return cell.getCellFormula();
//			default:
//				return "";
//		}
		// DataFormatter
        DataFormatter dataFormatter = new DataFormatter();
     // ʹDataFormatterȡԪʾֵ
        String cellValue = dataFormatter.formatCellValue(cell);
        return cellValue;
        
        
	}
}