package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;
import com.connor.jd.plm.table.MyCellEditor4;
import com.connor.jd.plm.table.TCTableUtil;
import com.connor.jd.plm.utils.DBUtil;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.db.Db;
import cn.hutool.db.Entity;

public class ComponentTestFrame extends JFrame {
	private CTMap model;
	private CTable table;
	private int bottom;
	private Container container;
	private TCComponentForm form;
	private TCSession session;
	private MyCallBack callBack;
	private String itemId;
	private String[] colNames = new String[] { "jd2_no", "jd2_wtry", "jd2_syxm", "jd2_syzq", "jd2_syts", "jd2_syfy",
			"jd2_sycs" };
	private TCComponentForm testForm;

	public ComponentTestFrame(Object itemId, TCComponentForm form, MyCallBack callBack) {
		this.itemId = StrUtil.toString(itemId);
		this.callBack = callBack;
		this.form = form;
		this.session = (TCSession) AIFUtility.getCurrentApplication().getSession();
		this.init();
	}

	private void init() {
		this.setTitle("Ŀ");
		this.setSize(560, 400);
		this.setResizable(true);
		this.setAlwaysOnTop(true);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		container = this.getContentPane();
		container.setLayout(new BorderLayout());
		container.setPreferredSize(new Dimension(600, 400));

		model = new CTMap(10, 7);
		model.setValueAt("", 0, 0);
		model.setValueAt("Ʒ", 0, 1);
		model.setValueAt("Ŀ", 0, 2);
		model.setValueAt("ʱ", 0, 3);
		model.setValueAt("Ʒ", 0, 4);
		model.setValueAt("", 0, 5);
		model.setValueAt("Ƿѡ", 0, 6);

		table = new CTable(model) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (row == 0 || col == 0) {
					return false;
				}
				return true;
			}
		};
		table.setRowHeight(25);
		table.setBorder(BorderFactory.createLineBorder(Color.black));
		for (int i = 0; i < model.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setPreferredWidth(80);
		}
		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				if (value instanceof JCheckBox) {
					return (JCheckBox) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table.setDefaultRenderer(Object.class, tcr1);
		table.getColumnModel().getColumn(6).setCellEditor(new MyCellEditor4(new JTextField()));

		// д
		Map<String, String[]> dataMap = new LinkedHashMap<>();
		try {
			List<Entity> list = Db.use(DBUtil.getDataSource(session)).findAll("JD2_COMPONENT");
			for (int i = 0; i < list.size(); i++) {
				String[] rowData = new String[6];
				rowData[0] = list.get(i).getStr("TEST_ID");
				rowData[1] = list.get(i).getStr("TEST_TYPE");
				rowData[2] = list.get(i).getStr("TEST_PROJECT");
				rowData[3] = list.get(i).getStr("TEST_TIME");
				rowData[4] = list.get(i).getInt("TEST_NUM") + "";
				rowData[5] = list.get(i).getInt("TEST_COST") == null ? "0" : list.get(i).getInt("TEST_COST") + "";
				dataMap.put(rowData[0], rowData);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			MessageBox.post("ݿô", "", MessageBox.ERROR);
			e.printStackTrace();
			return;
		}
		List<String> checkedId = new ArrayList<>();
		if (StrUtil.isNotBlank(itemId)) {
			try {
				TCComponent[] res = session.search("Item ID", new String[] { " ID" }, new String[] { itemId });
				if (ArrayUtil.isNotEmpty(res) && "JD2_GTCSJH".equals(res[0].getType())) {
					TCComponentItemRevision resRev = ((TCComponentItem) res[0]).getLatestItemRevision();
					TCComponent[] forms = resRev.getRelatedComponents("IMAN_master_form_rev");
					testForm = (TCComponentForm) forms[0];
					String[][] rowDatas = TCTableUtil.getTableRows(testForm, "jd2_csjh", colNames);
					for (int i = 0; i < rowDatas.length; i++) {
						checkedId.add(rowDatas[i][0]);
						String[] rowData = new String[6];
						rowData[0] = rowDatas[i][0];
						rowData[1] = "Զ";
						rowData[2] = rowDatas[i][2];
						rowData[3] = rowDatas[i][3];
						rowData[4] = rowDatas[i][4];
						rowData[5] = rowDatas[i][5];
						dataMap.put(rowDatas[i][0], rowData);
					}
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		bottom = dataMap.size();
		int row = 1;
		for (Entry<String, String[]> entry : dataMap.entrySet()) {
			if (row > model.getRowCount() - 1) {
				model.addRow();
			}
			model.setValueAt(entry.getValue()[0], row, 0);
			model.setValueAt(entry.getValue()[1], row, 1);
			model.setValueAt(entry.getValue()[2], row, 2);
			model.setValueAt(entry.getValue()[3], row, 3);
			model.setValueAt(entry.getValue()[4], row, 4);
			model.setValueAt(entry.getValue()[5], row, 5);
			if (checkedId.contains(entry.getValue()[0])) {
				JCheckBox tempCheck = new JCheckBox();
				tempCheck.setSelected(true);
				model.setValueAt(tempCheck, row, 6);
			} else {
				model.setValueAt(new JCheckBox(), row, 6);
			}
			row++;
		}

		// ť
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		JButton createTest = new JButton("/²Լƻ");
		createTest.addActionListener(createTest());
		JButton addTestItem = new JButton("");
		addTestItem.addActionListener(addTestItem());
		JButton cancel = new JButton("ȡ");
		cancel.addActionListener(cancel());
		buttonPanel.add(createTest);
		buttonPanel.add(addTestItem);
		buttonPanel.add(cancel);

		ScrollPane scrollPane = new ScrollPane();
		scrollPane.add(table);

		container.add(scrollPane, BorderLayout.CENTER);
		container.add(buttonPanel, BorderLayout.SOUTH);

		this.setVisible(true);
	}

	private ActionListener createTest() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				try {
					if (testForm != null) {// 
						String[] propNames = new String[] { "jd2_no", "jd2_syxh", "jd2_symd", "jd2_wtry", "jd2_syxm",
								"jd2_syts", "jd2_syzq", "jd2_syfy", "jd2_jhrc", "jd2_jhrc1", "jd2_sjrc", "jd2_sjrc1",
								"jd2_syzt", "jd2_syjg", "jd2_sycs", "jd2_syry", "jd2_csbg", "jd2_bz" };
						List<Map<String, String>> oldRowData = TCTableUtil.getTableMapList(testForm, "jd2_csjh",
								propNames);
						List<String> selectedNo = new ArrayList<>();
						for (int i = 1; i <= bottom; i++) {
							JCheckBox jb = (JCheckBox) model.getValueAt(i, 6);
							if (jb.isSelected()) {
								String no = model.getValueAt(i, 0).toString();
								selectedNo.add(no);
								boolean isInclude = false;
								for (int ii = 0; ii < oldRowData.size(); ii++) {// ޸
									if (no.equals(oldRowData.get(ii).get("jd2_no"))) {
										isInclude = true;
										oldRowData.get(ii).put("jd2_syxm", model.getValueAt(i, 2).toString());
										oldRowData.get(ii).put("jd2_syzq", model.getValueAt(i, 3).toString());
										oldRowData.get(ii).put("jd2_syts", model.getValueAt(i, 4).toString());
										oldRowData.get(ii).put("jd2_syfy", model.getValueAt(i, 5).toString());
									}
								}
								if (!isInclude) {// 
									Map<String, String> tempMap = new HashMap<String, String>();
									tempMap.put("jd2_no", no);
									tempMap.put("jd2_wtry", form.getTCProperty("owning_user").getUIFValue());
									tempMap.put("jd2_syxm", model.getValueAt(i, 2).toString());
									tempMap.put("jd2_syzq", model.getValueAt(i, 3).toString());
									tempMap.put("jd2_syts", model.getValueAt(i, 4).toString());
									tempMap.put("jd2_syfy", model.getValueAt(i, 5).toString());
									oldRowData.add(tempMap);
								}
							}
						}
						for (int i = 0; i < oldRowData.size(); i++) {// ɾ
							if (!selectedNo.contains(oldRowData.get(i).get("jd2_no"))) {
								oldRowData.remove(i);
								i--;
							}
						}
						TCTableUtil.setTableMapList(testForm, "jd2_csjh", "JD2_CSJHTABLE", oldRowData);
						callBack.execute(itemId);
					} else {// 
						TCComponentItemRevision rev = (TCComponentItemRevision) form.whereReferenced()[0]
								.getComponent();

						TCComponentItemType type = (TCComponentItemType) session.getTypeComponent("Item");
						TCComponentItem item = type.create(null, null, "JD2_GTCSJH", "Լƻ", "", null);
						rev.add("JD2_CSJH", item);
						TCComponentItemRevision rev1 = item.getLatestItemRevision();
						TCComponentForm form1 = (TCComponentForm) rev1.getRelatedComponents("IMAN_master_form_rev")[0];

						List<String[]> list = new ArrayList<String[]>();
						String[] row = new String[7];
						for (int i = 1; i <= bottom; i++) {
							JCheckBox jb = (JCheckBox) model.getValueAt(i, 6);
							if (jb.isSelected()) {
								for (int ii = 2; ii < 6; ii++) {
									row[ii - 2] = model.getValueAt(i, ii) == null ? ""
											: model.getValueAt(i, ii).toString();
								}
//								TCComponentPerson p = (TCComponentPerson) session.getUser().getUserInformation().get(0);
								list.add(new String[] { model.getValueAt(i, 0).toString(),
										form.getTCProperty("owning_user").getUIFValue(), row[0], row[1], row[2], row[3],
										"1" });
							}
						}
						String[][] data = list.toArray(new String[list.size()][7]);
						TCTableUtil.setTableRows(form1, "jd2_csjh", "JD2_CSJHTABLE", colNames, data);
						callBack.execute(item.getProperty("item_id"));
					}
					dispose();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		};
	}

	private ActionListener addTestItem() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				if (bottom > model.getRowCount() - 2) {
					model.addRow();
				}
				int num = Math.max(Integer.parseInt(model.getValueAt(bottom, 0).toString()), 10000);
				model.setValueAt(num + 1, ++bottom, 0);
				model.setValueAt(new JCheckBox(), bottom, 6);
			}
		};
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		container.removeAll();
		super.dispose();
	}

	private ActionListener cancel() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				dispose();
			}
		};
	}

}
