package com.connor.jd.plm.signingAndApprovalRecordHistory;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SpinnerDateModel;
import javax.swing.table.DefaultTableModel;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentProcess;
import com.teamcenter.rac.kernel.TCComponentTask;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.core.util.PageUtil;

public class RecordHistoryDialog extends AbstractAIFDialog implements ActionListener{
	private AbstractAIFApplication application;
	private TCSession tcSession ;
	private JTable table;
    private JComboBox<String> operationComboBox;
    private JComboBox<String> changePageSizeComboBox;
    private JButton queryButton, prevPageButton, nextPageButton, changeSizeButton;
    private int currentPageNum;
    private int pageSize = 20;//ÿҳ
    private DefaultTableModel model;
    private List<String[]> data = new ArrayList<String[]>();//ѯ

	private JSpinner startDatePicker;
	private JSpinner endDatePicker;
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-M-dd HH:mm");

	public RecordHistoryDialog(AbstractAIFApplication application) {
		super(true);
		this.application = application;
		this.tcSession = (TCSession) this.application.getSession();
	}
	
	@Override
	public void run() {
		try {
			initUi();
		} catch (Exception e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		}
	}
	
	private void initUi() throws Exception {
		this.setTitle("ҵǩ¼");
		this.setSize(800,600);
		this.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		
		// ģ
        String[] columnNames = {"", "ID", "", "汾", "", "", "Uid", "", "ע"};
         // ʼΪ
        this.model = new DefaultTableModel(columnNames,0){
			@Override
			public boolean isCellEditable(int row, int column) {
				return false;// еԪΪɱ༭
			}
		};
        this.table = new JTable(this.model);
        JScrollPane scrollPane = new JScrollPane(this.table);

		// ˫
		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				System.out.println("ѡ¼~");
				if (e.getClickCount() == 2) { // ǷΪ˫¼
					System.out.println("˫ѡ¼~");
					int row = table.rowAtPoint(e.getPoint());
					if (row >= 0) {
						// ȡ˫е
//						String objID = (String) model.getValueAt(row, 1);
//						String objName = (String) model.getValueAt(row, 2);
//						String versionNum = (String) model.getValueAt(row, 3);
//						String approvalOperation = (String) model.getValueAt(row, 4);
//						String flowName = (String) model.getValueAt(row, 5);
//						String dateValue = (String) model.getValueAt(row, 6);
//						String remark = (String) model.getValueAt(row, 7);
						String taskUid = (String) model.getValueAt(row, 6);

						// ˫ĲʾϸϢ
//						System.out.println("˫: " + row);
						System.out.println("ID: " + taskUid);
//						System.out.println(": " + objName);
//						System.out.println("汾: " + versionNum);
//						System.out.println(": " + approvalOperation);
//						System.out.println(": " + flowName);
//						System.out.println(": " + dateValue);
//						System.out.println("ע: " + remark);
						
						if (!taskUid.isEmpty()) {
							System.out.println("Double-clicked taskUID: " + taskUid);
							com.teamcenter.rac.common.Activator.getDefault()
									.openPerspective("com.teamcenter.rac.ui.perspectives.navigatorPerspective");
							try {
								InterfaceAIFComponent chooseComponent = tcSession.stringToComponent(taskUid);
								if (chooseComponent != null) {
									com.teamcenter.rac.common.Activator.getDefault().openComponents(
											"com.teamcenter.rac.ui.perspectives.navigatorPerspective",
											new InterfaceAIFComponent[]{chooseComponent});
								}else {
									System.out.println("δȡ˫ѡж");
								}
								
							} catch (Exception e1) {
								// TODO Զɵ catch 
								e1.printStackTrace();
							}
						}
					}
				}
			}

			/**
			 * itemIDcomponent
			 * @param objID
			 * @return
			 * @throws Exception 
			 */
			private InterfaceAIFComponent getItemById(String objID) throws Exception {
				InterfaceAIFComponent component = null;
				TCComponent[] searchs = tcSession.search("...", new String[] { " ID" },
						new String[] { objID });
				if (searchs.length > 0) {
					return searchs[0];
				}
				
				return null;
			}
		});

     // ѯ
        JPanel queryPanel = new JPanel(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();

        JPanel dateQueryPanel = createDateQueryPanel();//ʱѯ
        JPanel operationQueryPanel = createOperationQueryPanel();//Ͳѯ
        
        gbc.weightx = 0.7; // 70% of the available space
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridx = 0;
        gbc.gridy = 0;
        queryPanel.add(dateQueryPanel, gbc);
        gbc.weightx = 0.3; // 30% of the available space
        gbc.gridx = 1;
        gbc.gridy = 0;
        queryPanel.add(operationQueryPanel, gbc);
        

        // ť
        JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));

        JPanel pageNumChangePanel = createPageNumChoosePanel();
        prevPageButton = new JButton("һҳ");
        prevPageButton.addActionListener(this);
        nextPageButton = new JButton("һҳ");
        nextPageButton.addActionListener(this);
        buttonPanel.add(pageNumChangePanel);
        buttonPanel.add(prevPageButton);
        buttonPanel.add(nextPageButton);

        // 
        this.setLayout(new BorderLayout());
        this.add(queryPanel, BorderLayout.NORTH);
        this.add(scrollPane, BorderLayout.CENTER);
        this.add(buttonPanel, BorderLayout.SOUTH);

        this.setVisible(true);
	}
	
	/*
	 * ʱѯť
	 */
	private JPanel createDateQueryPanel() throws Exception {
        JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        JLabel label = new JLabel("ʱβѯ:");
        //һ㹻СĿʼʱ
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-d HH:mm");
        Date stDate = sdf.parse("1998-1-1 00:00");
        
     // һSpinnerDateModelĬֵΪǰʱ
        SpinnerDateModel startModel = new SpinnerDateModel();
//        SpinnerDateModel startModel = new SpinnerDateModel(stDate, null, null, Calendar.DAY_OF_MONTH);
        this.startDatePicker = new JSpinner(startModel);

        // ñ༭ΪJSpinner.DateEditorʾѺøʽ
        JSpinner.DateEditor startEditor = new JSpinner.DateEditor(this.startDatePicker, "yyyy-M-dd HH:mm");
        this.startDatePicker.setEditor(startEditor);

        // ԽʱͬĴ
        SpinnerDateModel endModel = new SpinnerDateModel();
        this.endDatePicker = new JSpinner(endModel);
        JSpinner.DateEditor endEditor = new JSpinner.DateEditor(this.endDatePicker, "yyyy-M-dd HH:mm");
        this.endDatePicker.setEditor(endEditor);

        panel.add(label);
        panel.add(this.startDatePicker);
        panel.add(new JLabel("~"));
        panel.add(this.endDatePicker);

        return panel;
    }

	/*
	 * Ͳѯť
	 */
    private JPanel createOperationQueryPanel() {
        JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        JLabel label = new JLabel("ѯ:");
        operationComboBox = new JComboBox<>(new String[]{"׼", ""});
        queryButton = new JButton("ѯ");
        
        queryButton.addActionListener(this);

        panel.add(label);
        panel.add(operationComboBox);
        panel.add(queryButton);

        return panel;
    }
    
	/* 
	 * 	ҳС
	 */
   private JPanel createPageNumChoosePanel() {
       JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
       JLabel label = new JLabel("ҳС:");
       changePageSizeComboBox = new JComboBox<>(new String[]{"20", "30","50","100","200","500"});
       changeSizeButton = new JButton("л");
       
       changeSizeButton.addActionListener(this);

       panel.add(label);
       panel.add(changePageSizeComboBox);
       panel.add(changeSizeButton);

       return panel;
   }
    
    /*
     *	 ݵ
     *	@data: 
     *	@currentPageNum: ǰҳ:[1,2,3,4,5,6...]
     */
    private void updateTable(List<String[]> data, int currentPageNum) {
    	System.out.println("ݵΣǰҳ="+currentPageNum);
        int totalNum = data.size();//
        int totalPage = PageUtil.totalPage(totalNum, this.pageSize);
        System.out.println("ҳ"+totalPage);//3
        System.out.println(""+totalNum);
        if (currentPageNum <= totalPage) {
        	if (this.model.getRowCount() > 0) {
                // ձݣб
        		System.out.println("ʼձݣб");
                for (int i = this.model.getRowCount() - 1; i >= 0; i--) {
                    this.model.removeRow(i);
                }
            }
        	//ȡǰҳʼλõ
        	int[] startEnd = PageUtil.transToStartEnd(currentPageNum, pageSize);
        	int start = startEnd[0];
        	int end = startEnd[1];
        	if (end>totalNum) {
        		System.out.println("end = "+end+",totalNum = "+totalNum);
				end = totalNum;
			}
        	System.out.println("Ⱦбе䣺"+start+" = "+end);
        	for (int i = start; i < end; i++) {
        		model.addRow(data.get(i));//TODO
    		}
		}else {
			System.out.println("ǰҳ볬ҳ");
			this.currentPageNum = totalPage;
			MessageBox.post("ǰҳ볬ҳ","ҳʾ",MessageBox.INFORMATION);
		}
    }
    
    private InterfaceAIFComponent[] searchRecord(List<String> entryNames,List<String> entryValues) throws Exception {
    	//ÿβѯǰõǰҳ
    	this.currentPageNum = 1;
    	
    	int nameNum = entryNames.size();
    	int valueNum = entryValues.size();
    	InterfaceAIFComponent[] resultComponents = null;
    	if (nameNum>0 && valueNum>0) {
    		for(String s:entryValues) {
    			System.out.println("ѯΣ"+s);
    		}
    		//òѯ
            resultComponents = tcSession.search("ǩ¼ѯ", 
    				entryNames.toArray(new String[valueNum]), 
    				entryValues.toArray(new String[valueNum]));
            if (resultComponents.length>0) {
				System.out.println("ǩ¼ѯɹѯ"+resultComponents.length+"");
				if (this.data != null && this.data.size() > 0) {//java.lang.NullPointerException
					this.data.clear();//ÿβѯʱdata
				}
		    	
			}else {
				System.out.println("ǩ¼δѯκν");
			}
		}else {
			System.out.println("δȷѯĲѯĿͲ˶ԣ");
		}
		return resultComponents;
	}
    

	 // ·ڻȡʼʱѡֵʽΪַ
	 public String getFormattedStartDate() {
	     Date date = (Date) startDatePicker.getValue();
	     return dateFormat.format(date);
	 }
	
	 // ·ڻȡʱѡֵʽΪַ
	 public String getFormattedEndDate() {
	     Date date = (Date) endDatePicker.getValue();
	     return dateFormat.format(date);
	 }

	@Override
	public void actionPerformed(ActionEvent e) {
		String userName = tcSession.getUserName();
		Object s = e.getSource();
		try {
			if (s.equals(this.queryButton)) {
				//ͨͲѯ
				String startDate = null;
				String endDate = null;
				String operation = null;
				String input = (String) operationComboBox.getSelectedItem();
				System.out.println("ݲͲѯΣ"+input);
				if (input.equals("׼")) {
					operation = "׼";
				}else if (input.equals("")) {
					operation = "Ѿܾ";
				}
				startDate = getFormattedStartDate();
	            endDate = getFormattedEndDate();
	            System.out.println(startDate+"<->"+endDate);
				
	            List<String> entryNames = new ArrayList<String>();
				List<String> entryValues = new ArrayList<String>();
				int cxtag = 0;
				if (startDate != null && startDate != "") {
					cxtag++;
					entryNames.add("ʼ");
					entryValues.add(startDate);
					System.out.println("ѯ-ʼڣ"+startDate);
				}
				if (endDate != null && endDate != "") {
					cxtag++;
					entryNames.add("ʼ");
					entryValues.add(endDate);
					System.out.println("ѯ-ڣ"+endDate);
				}
				if (operation != null && operation != "") {
					cxtag++;
					entryNames.add("ǩ");
					entryValues.add(operation);
					System.out.println("ѯ-ǩ"+operation);
				}
				if (cxtag != 0) {
					entryNames.add("");
					entryValues.add(userName);
					System.out.println("ѯ-ߣ"+userName);
				}
				//òѯ
				InterfaceAIFComponent[] results = searchRecord(entryNames,entryValues);
				if (results.length>0) {
					delSearchResult(results);
				}else {
					MessageBox.post("δѯκνѯǷȷ","ѯ",MessageBox.INFORMATION);
				}
			}else if (s.equals(this.nextPageButton)) {
				//һҳ
				System.out.println("һҳ");
				this.currentPageNum ++;
				updateTable(this.data, currentPageNum);
				
			}else if (s.equals(this.prevPageButton)) {
				//һҳ
				System.out.println("һҳ");
				if (this.currentPageNum >1) {
					this.currentPageNum --;
					updateTable(this.data, currentPageNum);
				}else {
					System.out.println("Ѿһҳ");
					this.currentPageNum = 0;
					MessageBox.post("Ѿһҳ","ҳʾ",MessageBox.INFORMATION);
				}
			}else if (s.equals(this.changeSizeButton)) {
				String selectPageSizeString = (String)changePageSizeComboBox.getSelectedItem();
				this.pageSize = Integer.parseInt(selectPageSizeString);
				System.out.println("лҳС"+selectPageSizeString);
				this.currentPageNum = 1;
				updateTable(this.data, currentPageNum);
			}
		} catch (Exception e2) {
			e2.printStackTrace();
		}
		
	}

	/*
	 * ѯõݣ
	 */
	public void delSearchResult(InterfaceAIFComponent[] results) {
		try {
			if (results != null) {
				int xh = 0;
				for (InterfaceAIFComponent component : results) {//ڵcomponent
					TCComponentTask componenttsTask = (TCComponentTask)component;
					String uid = componenttsTask.getReferenceProperty("fnd0RootTask").getUid();
					System.out.println("===ȡڵfnd0RootTaskuid="+uid);
					TCComponentTask process = (TCComponentTask)(componenttsTask.getReferenceProperty("fnd0RootTask"));//
					TCComponent[] components = process.getReferenceListProperty("root_target_attachments");
					System.out.println("ʼȡڵ");
//					ȡڵ
					String dataValue = component.getProperty("fnd0StartDate");
					String approvalOperation = component.getProperty("task_result");
					String flowName = component.getProperty("fnd0TaskPathName");
					String taskUid = component.getUid();
					
					for (InterfaceAIFComponent flowComponent : components) {
						if (flowComponent instanceof TCComponentItemRevision) {
							System.out.println("ȡ¶");
							//ȡ¶
							TCComponentItemRevision itemRevision = (TCComponentItemRevision) flowComponent;
							String item = itemRevision.getStringProperty("item_id");
							String obj = itemRevision.getStringProperty("object_name");
							String rev = itemRevision.getStringProperty("item_revision_id");
							//֯
							xh = xh + 1;
							//
							RecordHistoryEntity entity = new RecordHistoryEntity();
							entity.setNum(String.valueOf(xh));
							entity.setObjID(item == null ? "" : item);
							entity.setObj(obj == null ? "" : obj);
							entity.setVersionNum(rev == null ? "" : rev);
							entity.setApprovalOperation(approvalOperation == null ? "" : approvalOperation);
							entity.setFlowName(flowName == null ? "" : flowName);
							entity.setDateValue(dataValue == null ? "" : dataValue);
							entity.setRemark("");
							entity.setTaskUid(taskUid == null ? "" : taskUid);
							
							System.out.println(entity.toString());
							this.data.add(new String[] {
								entity.getNum(),
								entity.getObjID(),
								entity.getObj(),
								entity.getVersionNum(),
								entity.getApprovalOperation(),
								entity.getFlowName(),
								entity.getTaskUid(),
								entity.getDateValue(),
								entity.getRemark()
							});
						}
					}
				}
				updateTable(this.data, this.currentPageNum);
				
			}else {
				System.out.println("ݿʼڲѯǩ¼ʧܣ");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
