package com.connor.jd.plm.utils;

import java.io.File;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import com.aspose.cells.Cells;
import com.aspose.cells.License;
import com.aspose.cells.Workbook;
import com.aspose.cells.WorksheetCollection;

public class SimpleExcelUtil {
	public static void exportExcel(String path, String[] header, List<String[]> data) {
		if (path == null || data == null) {
			return;
		}
		try {
			File file = new File(path);
			file.createNewFile();

			getLicense();

			Workbook excel = new Workbook(path);
			WorksheetCollection wc = excel.getWorksheets();
			Cells cells = wc.get(0).getCells();
			int rowIndex = 0;
			if (header != null) {
				for (int columnIndex = 0; columnIndex < header.length; columnIndex++) {
					cells.get(rowIndex, columnIndex).setValue(header[columnIndex]);
				}
				rowIndex++;
			}
			for (String[] arr : data) {
				for (int columnIndex = 0; columnIndex < arr.length; columnIndex++) {
					cells.get(rowIndex, columnIndex).setValue(arr[columnIndex]);
				}
				rowIndex++;
			}
			excel.save(path);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static boolean getLicense() throws Exception {
		boolean result = false;
		try {
			InputStream is = com.aspose.cells.Cell.class.getResourceAsStream("/com/aspose/cells/resources/license.xml");
			License aposeLic = new License();
			aposeLic.setLicense(is);
			result = true;
			is.close();
		} catch (Exception e) {
			e.printStackTrace(System.out);
			throw e;
		}
		return result;
	}

	public static void main(String[] args) {
		List<String[]> test = new ArrayList<String[]>();
		test.add(new String[] { "zzz", "xxx" });
		SimpleExcelUtil.exportExcel(System.getenv("temp") + File.separator + "xxxxxxxxxxxxxxxxxxxx.xlsx",
				new String[] { "1", "2" }, test);
		System.out.println(System.getenv("temp"));
	}
}
