package com.teamcenter.rac.commands.namedreferences;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import org.apache.log4j.Logger;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import com.teamcenter.rac.aif.AIFClipboard;
import com.teamcenter.rac.aif.AIFDesktop;
import com.teamcenter.rac.aif.AIFPortal;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.InterfaceAIFOperationListener;
import com.teamcenter.rac.aif.common.AIFIdentifier;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.AIFComponentEvent;
import com.teamcenter.rac.aif.kernel.AbstractAIFSession;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponentEventListener;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.commands.newdataset.DatasetUtil;
import com.teamcenter.rac.commands.newdataset.IFilesSelector;
import com.teamcenter.rac.commands.newdataset.TCFileDescriptor;
import com.teamcenter.rac.commands.newdataset.TCFileSelectorService;
import com.teamcenter.rac.common.Activator;
import com.teamcenter.rac.common.viewedit.ViewEditHelper;
import com.teamcenter.rac.kernel.NamedReferenceContext;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetDefinition;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.services.IPropertyPolicyService;
import com.teamcenter.rac.util.ButtonLayout;
import com.teamcenter.rac.util.ConfirmDialog;
import com.teamcenter.rac.util.ConfirmationDialog;
import com.teamcenter.rac.util.Cookie;
import com.teamcenter.rac.util.HorizontalLayout;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.OSGIUtil;
import com.teamcenter.rac.util.Registry;
import com.teamcenter.rac.util.Separator;
import com.teamcenter.rac.util.Utilities;
import com.teamcenter.rac.util.VerticalLayout;
import com.teamcenter.rac.util.log.Debug;
import com.teamcenter.soa.common.ObjectPropertyPolicy;
import com.teamcenter.soa.common.PolicyType;

public class NamedReferencesDialog extends AbstractAIFDialog implements InterfaceAIFComponentEventListener {
	private static final Logger logger = Logger.getLogger(NamedReferencesDialog.class);

	private JTable table;

	private JScrollPane tableScrollPane;

	private NamedReferencesTableModel model;

	private JButton openButton;

	private JButton importButton;

	private JButton exportButton;

	private JButton cutButton;

	private JButton copyButton;

	private JButton pasteButton;

	private JButton deleteButton;

	private Window parent;

	private AbstractAIFSession session;

	private Registry appReg;

	private TCComponentDataset datasetComponent = null;

	private String truncateFileName = "FALSE";

	private static String[] sourceClassificationString;

	private static String[] destClassificationString;

	String[] prop = { "ip_classification", "gov_classification" };

	public static final String OBJECT_NAME_COLUMN_ID = "object_name";

	public static final String TCFILE_NAME_COLUMN_ID = "original_file_name";

	public static final String SIZE_COLUMN_ID = "file_size";

	public static final String REMOTE_COLUMN_ID = "owning_site";

	public static final String TYPE_COLUMN_ID = "object_type";

	public static final String LASTMODIFIED_COLUMN_ID = "last_mod_date";

	public static final String VOLUME_COLUMN_ID = "volume_tag";

	public static final String REF_LIST = "ref_list";

	public static final String REF_NAMES = "ref_names";

	public static final String ADDITIONAL_COLUMN = "com.teamcenter.rac.commands.namedreferences.AdditionalColumnShown";

	public static final String TC_TRUNCATE_FILE_NAME = "TC_truncate_file_name";

	protected JFileChooser exportFc;

	private TCComponent[] toolComponents;

	private TCComponent selectedToolComponent;

	private static String fileNamePolicy;

	public NamedReferencesDialog(TCComponentDataset paramTCComponentDataset, Frame paramFrame) {
		super(paramFrame, true);
		this.parent = paramFrame;
		this.session = paramTCComponentDataset.getSession();
		this.datasetComponent = paramTCComponentDataset;
		initializeDialog();
	}

	public NamedReferencesDialog(TCComponentDataset paramTCComponentDataset, Dialog paramDialog) {
		super(paramDialog, true);
		this.parent = paramDialog;
		this.session = paramTCComponentDataset.getSession();
		this.datasetComponent = paramTCComponentDataset;
		initializeDialog();
	}

	public NamedReferencesDialog(TCComponentDataset paramTCComponentDataset) {
		super(true);
		this.session = paramTCComponentDataset.getSession();
		this.datasetComponent = paramTCComponentDataset;
		initializeDialog();
	}

	private void initializeDialog() {
		this.appReg = Registry.getRegistry(this);
		setTitle(this.appReg.getString("command.TITLE"));
		setModal(false);
		JPanel jPanel1 = new JPanel(new VerticalLayout(5, 2, 2, 2, 2));
		getContentPane().add(jPanel1);
		JPanel jPanel2 = new JPanel(new HorizontalLayout(2, 2, 2, 2, 2));
		JPanel jPanel3 = new JPanel(new ButtonLayout());
		TCPreferenceService tCPreferenceService = ((TCSession) this.session).getPreferenceService();
		String[] arrayOfString = tCPreferenceService.getStringArray(0,
				"com.teamcenter.rac.commands.namedreferences.AdditionalColumnShown");
		this.truncateFileName = tCPreferenceService.getString(0, "TC_truncate_file_name");
		this.model = new NamedReferencesTableModel(arrayOfString);
		this.table = new JTable(this.model);
		this.table.setPreferredScrollableViewportSize(new Dimension(550, 100));
		RightTextRenderer rightTextRenderer = new RightTextRenderer();
		TableColumn tableColumn1 = getTableColumnByName("file_size");
		tableColumn1.setCellRenderer(rightTextRenderer);
		this.table.setAutoResizeMode(0);
		this.tableScrollPane = new JScrollPane(this.table);
		DefaultTableCellRenderer defaultTableCellRenderer = new DefaultTableCellRenderer();
		defaultTableCellRenderer.setToolTipText(this.appReg.getString("changeFileName.TIP"));
		TableColumn tableColumn2 = getTableColumnByName("original_file_name");
		tableColumn2.setCellRenderer(defaultTableCellRenderer);
		AIFIdentifier[] arrayOfAIFIdentifier1 = this.model.getColumnIdentifiers();
		AIFIdentifier[] arrayOfAIFIdentifier2;
		arrayOfAIFIdentifier2 = arrayOfAIFIdentifier1;
		int i = arrayOfAIFIdentifier1.length;
		for (byte b = 0; b < i; b++) {
			AIFIdentifier aIFIdentifier = arrayOfAIFIdentifier2[b];
			TableColumn tableColumn = getTableColumnByName((String) aIFIdentifier.getColumnId());
			if (aIFIdentifier.getClientData() != null) {
				Integer integer = (Integer) aIFIdentifier.getClientData();
				tableColumn.setPreferredWidth(integer.intValue());
			}
		}
		JPanel jPanel4 = new JPanel(new ButtonLayout());
		this.openButton = new JButton(this.appReg.getString("open"));
		this.openButton.setMnemonic(this.appReg.getString("open.MNEMONIC").charAt(0));
		this.openButton.setToolTipText(this.appReg.getString("open.TOOLTIP"));
		this.importButton = new JButton(this.appReg.getString("importbutton"));
		this.importButton.setMnemonic(this.appReg.getString("import.MNEMONIC").charAt(0));
		this.importButton.setToolTipText(this.appReg.getString("import.TOOLTIP"));
		this.exportButton = new JButton(this.appReg.getString("exportbutton"));
		this.exportButton.setMnemonic(this.appReg.getString("export.MNEMONIC").charAt(0));
		this.exportButton.setToolTipText(this.appReg.getString("export.TOOLTIP"));
		jPanel4.add(this.openButton);
		jPanel4.add(this.importButton);
		jPanel4.add(this.exportButton);
		JPanel jPanel5 = new JPanel(new HorizontalLayout());
		this.cutButton = new JButton(this.appReg.getImageIcon("cut.ICON"));
		this.cutButton.setFocusPainted(false);
		this.cutButton.setMargin(new Insets(0, 0, 0, 0));
		this.cutButton.setToolTipText(this.appReg.getString("cut.TOOLTIP"));
		this.copyButton = new JButton(this.appReg.getImageIcon("copy.ICON"));
		this.copyButton.setFocusPainted(false);
		this.copyButton.setMargin(new Insets(0, 0, 0, 0));
		this.copyButton.setToolTipText(this.appReg.getString("copy.TOOLTIP"));
		this.pasteButton = new JButton(this.appReg.getImageIcon("paste.ICON"));
		this.pasteButton.setFocusPainted(false);
		this.pasteButton.setMargin(new Insets(0, 0, 0, 0));
		this.pasteButton.setToolTipText(this.appReg.getString("paste.TOOLTIP"));
		this.deleteButton = new JButton(this.appReg.getImageIcon("delete.ICON"));
		this.deleteButton.setFocusPainted(false);
		this.deleteButton.setMargin(new Insets(0, 0, 0, 0));
		this.deleteButton.setToolTipText(this.appReg.getString("remove.TOOLTIP"));
		jPanel5.add("right.nobind.center.center", this.deleteButton);
		jPanel5.add("right.nobind.center.center", this.pasteButton);
		jPanel5.add("right.nobind.center.center", this.copyButton);
		jPanel5.add("right.nobind.center.center", this.cutButton);
		jPanel2.add("left.nobind.left.center", jPanel4);
		jPanel2.add("right.nobind.right.center", jPanel5);
		JButton jButton = new JButton(this.appReg.getString("close"));
		jButton.setMnemonic(this.appReg.getString("close.MNEMONIC").charAt(0));
		jPanel3.add(jButton);
		JLabel jLabel1 = new JLabel(this.appReg.getImageIcon("namedreferences.ICON"), 0);
		JLabel jLabel2 = new JLabel(this.appReg.getImageIcon("modeless.ICON"));
		jLabel2.setToolTipText(this.appReg.getString("modeless.TOOLTIP"));
		String str = allowedNameReferenceModification() ? "" : this.appReg.getString("CheckoutNamedRef.INFOMESSAGE");
		JLabel jLabel3 = new JLabel(str, 0);
		JPanel jPanel6 = new JPanel(new HorizontalLayout(2, 0, 0, 0, 0));
		jPanel6.add("left", jLabel1);
		jPanel6.add("left", jLabel3);
		jPanel6.add("right", jLabel2);
		jPanel1.add("top", jPanel6);
		jPanel1.add("top.bind", new Separator());
		jPanel1.add("bottom.bind.center.top", jPanel3);
		jPanel1.add("bottom.bind", new Separator());
		jPanel1.add("bottom.bind", jPanel2);
		jPanel1.add("unbound.bind.center.top", this.tableScrollPane);
		this.importButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startImportFilesOperation();
			}
		});
		this.exportButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startExportFilesOperation();
			}
		});
		this.openButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startOpenFileOperation();
			}
		});
		this.copyButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startCopyOperation();
			}
		});
		this.cutButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startCutNamedRefOperation();
			}
		});
		this.pasteButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startPasteOperation();
			}
		});
		this.deleteButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.startDeleteNamedRefOperation();
			}
		});
		jButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent param1ActionEvent) {
				NamedReferencesDialog.this.closePressed();
			}
		});
		pack();
		centerToScreen(1.5D, 1.0D);
		jButton.requestFocusInWindow();
		AbstractAIFOperation abstractAIFOperation = new AbstractAIFOperation() {
			@Override
			public void executeOperation() {
				ArrayList arrayList = new ArrayList();
				arrayList.add(NamedReferencesDialog.this.datasetComponent);
				TCComponentType.refresh(arrayList);
			}
		};
		abstractAIFOperation.addOperationListener(new InterfaceAIFOperationListener() {
			@Override
			public void startOperation(String param1String) {
			}

			@Override
			public void endOperation() {
				NamedReferencesDialog.this.loadNamedReferences();
			}
		});
		this.session.queueOperation(abstractAIFOperation);
		this.session.addAIFComponentEventListener(this);
		validateButtons();
		this.table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent param1ListSelectionEvent) {
				NamedReferencesDialog.this.validateButtons();
			}
		});
		this.table.addKeyListener(new KeyListener() {
			@Override
			public void keyTyped(KeyEvent param1KeyEvent) {
			}

			@Override
			public void keyReleased(KeyEvent param1KeyEvent) {
			}

			@Override
			public void keyPressed(KeyEvent param1KeyEvent) {
				if (param1KeyEvent.isControlDown() && param1KeyEvent.getKeyCode() == 67) {
					Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
					StringBuilder stringBuilder = new StringBuilder();
					int[] arrayOfInt1 = NamedReferencesDialog.this.table.getSelectedRows();
					int i = NamedReferencesDialog.this.table.getColumnCount();
					int[] arrayOfInt2;
					arrayOfInt2 = arrayOfInt1;
					int j = arrayOfInt1.length;
					for (byte b = 0; b < j; b++) {
						int k = arrayOfInt2[b];
						for (byte b1 = 0; b1 < i; b1++) {
							String str = String.valueOf(NamedReferencesDialog.this.table.getModel().getValueAt(k, b1));
							stringBuilder.append(str).append("\t");
						}
						stringBuilder.append("\n");
					}
					StringSelection stringSelection = new StringSelection(stringBuilder.toString());
					clipboard.setContents(stringSelection, null);
				}
			}
		});
	}

	@Override
	public void run() {
		setVisible(true);
	}

	public void closePressed() {
		this.session.removeAIFComponentEventListener(this);
		TableColumnModel tableColumnModel = this.table.getColumnModel();
		int i = tableColumnModel.getColumnCount();
		String[] arrayOfString1 = new String[i];
		String[] arrayOfString2 = new String[i];
		AIFIdentifier[] arrayOfAIFIdentifier = this.model.getColumnIdentifiers();
		for (byte b = 0; b < i; b++) {
			TableColumn tableColumn = tableColumnModel.getColumn(b);
			Integer integer = new Integer(tableColumn.getWidth());
			arrayOfString2[b] = integer.toString();
			arrayOfString1[b] = getPropertyName(this.table.getColumnName(b), arrayOfAIFIdentifier);
		}
		try {
			Cookie cookie = Cookie.getCookie("namedreference", true);
			cookie.setStringArray("columnname", arrayOfString1);
			cookie.setStringArray("columnwidth", arrayOfString2);
			cookie.close();
		} catch (Exception exception) {
		}
		disposeDialog();
	}

	private String getPropertyName(String paramString, AIFIdentifier[] paramArrayOfAIFIdentifier) {
		String str = "";
		if (paramArrayOfAIFIdentifier != null) {
			AIFIdentifier[] arrayOfAIFIdentifier;
			arrayOfAIFIdentifier = paramArrayOfAIFIdentifier;
			int i = paramArrayOfAIFIdentifier.length;
			for (byte b = 0; b < i; b++) {
				AIFIdentifier aIFIdentifier = arrayOfAIFIdentifier[b];
				if (aIFIdentifier.getColumnName().equals(paramString)) {
					str = (String) aIFIdentifier.getColumnId();
					break;
				}
			}
		}
		return str;
	}

	private TableColumn getTableColumnByName(String paramString) {
		byte b1 = 0;
		AIFIdentifier[] arrayOfAIFIdentifier = this.model.getColumnIdentifiers();
		for (byte b2 = 0; b2 < arrayOfAIFIdentifier.length; b2++) {
			if (paramString.equals(arrayOfAIFIdentifier[b2].getColumnId())) {
				b1 = b2;
				break;
			}
		}
		return this.table.getColumnModel().getColumn(b1);
	}

	private int[] checkTableSelection(boolean paramBoolean1, boolean paramBoolean2) {
		int[] arrayOfInt = this.table.getSelectedRows();
		if (arrayOfInt == null || arrayOfInt.length == 0) {
			if (paramBoolean2)
				MessageBox.post(this.parent, this.appReg.getString("noSelection"),
						this.appReg.getString("warning.TITLE"), 4);
			return null;
		}
		if (!paramBoolean1 && arrayOfInt.length > 1) {
			if (paramBoolean2)
				MessageBox.post(this.parent, this.appReg.getString("noMultipleSelection"),
						this.appReg.getString("warning.TITLE"), 4);
			return null;
		}
		return arrayOfInt;
	}

	private void startExportFilesOperation() {
		if (Debug.isOn("dataset,export"))
			Debug.println("==> startExportFilesOperation");
		int[] arrayOfInt = checkTableSelection(true, true);
		if (arrayOfInt == null)
			return;
		int i = arrayOfInt.length;
		Vector vector = new Vector();
		TCComponent tCComponent = null;
		for (byte b = 0; b < i; b++) {
			tCComponent = this.model.getComponentAt(arrayOfInt[b]);
			if (tCComponent instanceof TCComponentTcFile) {
				vector.addElement(tCComponent);
				final TCComponentTcFile tcFile = (TCComponentTcFile) tCComponent;

				// jd
				boolean flag = true;
				try {
					TCSession tcSession = (TCSession) this.session;
					TCPreferenceService service = tcSession.getPreferenceService();
					String[] pref = service.getStringValues("jd_dataset_download");
					String[] pref2 = service.getStringValues("jd_wl_type_classify");
					Map<String, List<String>> typeClassify = new HashMap<String, List<String>>();
					List<String> list = new ArrayList<String>();
					if (pref != null && pref.length > 0) {
						System.out.println("ѡ===>" + Arrays.toString(pref));
						list = Arrays.asList(pref);
					}
					if (pref2 != null && pref2.length > 0) {
						System.out.println("ѡ2===>" + Arrays.toString(pref2));
						for (String str : pref2) {
							String[] row = str.split(":");
							typeClassify.put(row[0], Arrays.asList(row[1].split(",")));
						}
					}
					AIFComponentContext[] parents = tcFile.whereReferenced();
					L1: for (AIFComponentContext aif : parents) {
						TCComponentDataset dataset = (TCComponentDataset) aif.getComponent();
						System.out.println(dataset.getProperty("object_string"));
						System.out.println(dataset.getType());
						if (list.contains(dataset.getType())) {
							flag = false;
							String currentUser = tcSession.getUser().getProperty("object_string");
							String owningUser = dataset.getProperty("owning_user");
							System.out.println("currentUser===>" + currentUser + ",owningUser===>" + owningUser);
							if (currentUser.equals(owningUser)) {
								System.out.println("");
								flag = true;
								break;
							}
							String loginGroup = tcSession.getUser().getProperty("login_group");
							System.out.println("loginGroup===>" + loginGroup);
							if (loginGroup.contains("dba")) {
								System.out.println("dba");
								flag = true;
								break;
							}
							AIFComponentContext[] revs = dataset.whereReferenced();
							for (AIFComponentContext aif1 : revs) {
								if (aif1.getComponent() != null
										&& (aif1.getComponent() instanceof TCComponentItemRevision)) {
									String type = aif1.getComponent().getType();
									System.out.println("===>" + type);
									if ((loginGroup.contains("зһ") && typeClassify.get("GT") != null
											&& typeClassify.get("GT").contains(type))
											|| (loginGroup.contains("з") && typeClassify.get("BL") != null
													&& typeClassify.get("BL").contains(type))
											|| (loginGroup.contains("з岿") && typeClassify.get("BX") != null
													&& typeClassify.get("BX").contains(type))) {
										System.out.println("");
										flag = true;
										break L1;
									}
								}
							}
						}
					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					logger.error(e.getLocalizedMessage(), e);
					e.printStackTrace();
				}
				if (!flag) {
					MessageBox.post(this.parent, "", "ʾ", MessageBox.WARNING);
					return;
				}

				if (this.exportFc == null) {
					this.exportFc = new JFileChooser(getDefaultExportDirectory());
					this.exportFc.setFileSelectionMode(0);
					this.exportFc.setApproveButtonText(this.appReg.getString("export"));
				}
				this.exportFc.rescanCurrentDirectory();
				String str1 = null;
				try {
					str1 = tcFile.getProperty("original_file_name");
				} catch (TCException tCException) {
					logger.error(tCException.getLocalizedMessage(), tCException);
					return;
				}
				this.exportFc.setDialogTitle(
						String.valueOf(this.appReg.getString("exportFile.TITLE")) + " " + str1 + " ... ");
				File file1 = this.exportFc.getCurrentDirectory();
				String str2 = String.valueOf(file1.getAbsolutePath()) + File.separator + str1;
				File file2 = new File(str2);
				int j = str1.lastIndexOf('.');
				String str3 = null;
				if (j == -1) {
					str3 = str1;
				} else {
					str3 = str1.substring(0, j);
				}
				if (Debug.isOn("dataset,export"))
					Debug.println("Processing TCComponentTcFile [" + tcFile + "] defaultFileLocation [" + str2
							+ "], file name [" + str1 + "] absFileName [" + str3 + "]");
				try {
					TCPreferenceService tCPreferenceService = ((TCSession) this.session).getPreferenceService();
					String str = tCPreferenceService.getString(0, "Dataset_File_Export_Option");
					if (Debug.isOn("dataset,export"))
						Debug.println("Pref [Dataset_File_Export_Option] value [" + str + "]");
					if (str != null && str.length() > 0)
						if (str.equalsIgnoreCase("LOWERCASE")) {
							file2 = new File(String.valueOf(file1.getAbsolutePath()) + File.separator
									+ str3.toLowerCase() + str1.substring(j));
						} else if (str.equalsIgnoreCase("UPPERCASE")) {
							file2 = new File(String.valueOf(file1.getAbsolutePath()) + File.separator
									+ str3.toUpperCase() + str1.substring(j));
						}
				} catch (Exception exception) {
					if (Debug.isOn("dataset,export"))
						Debug.printStackTrace(exception);
				}
				this.exportFc.setSelectedFile(file2);
				if (Debug.isOn("dataset,export"))
					Debug.println("setSelectedFile [" + file2.getName() + "]");
				File file3 = null;
				Frame frame = Utilities.getCurrentFrame();
				if (this.exportFc.showOpenDialog(frame) == 0)
					for (file3 = this.exportFc.getSelectedFile(); file3 != null && file3.exists(); file3 = null) {
						if (ConfirmationDialog.post(frame, this.appReg.getString("fileExist.TITLE"),
								this.appReg.getString("fileExists")) == 2) {
							if (Debug.isOn("dataset,export"))
								Debug.println("Deleting [" + file3.getName() + "]");
							if (!file3.delete()) {
								MessageBox.post(this.appReg.getString("exportFailure.MESSAGE"),
										this.appReg.getString("exportFailure.TITLE"), 4);
								file3 = null;
							}
							continue;
						}
						if (this.exportFc.showOpenDialog(frame) == 0) {
							file3 = this.exportFc.getSelectedFile();
							continue;
						}
					}
				if (Debug.isOn("dataset,export"))
					Debug.println("getSelectedFile [" + file3.getName() + "]");
				if (file3 != null) {
					final File realDirFile = file3;
					Utilities.setCookie("filechooser", true, "DatasetExport.DIR", realDirFile.getParent());
					this.session.queueOperation(new AbstractAIFOperation(
							String.valueOf(this.appReg.getString("exportingFiles")) + tcFile + " ...  ") {
						@Override
						public void executeOperation() {
							NamedReferencesDialog.this.executeExportOperation(tcFile, realDirFile);
						}
					});
				}
			}
		}
		if (vector.isEmpty()) {
			MessageBox.post(this.parent, this.appReg.getString("noValidExportSelection"),
					this.appReg.getString("warning.TITLE"), 4);
			return;
		}
	}

	protected void executeExportOperation(TCComponentTcFile paramTCComponentTcFile, File paramFile) {
		try {
			if (Debug.isOn("dataset,export"))
				Debug.println("getSelectedFile [" + paramFile.getName() + "] parent [[" + paramFile.getParent() + "]");
			paramTCComponentTcFile.getFile(this.datasetComponent, paramFile.getParent(), paramFile.getName());
		} catch (Exception exception) {
			if (Debug.isOn("dataset,export"))
				Debug.printStackTrace(exception);
			MessageBox.post(this.parent, exception);
		}
	}

	private void startImportFilesOperation() {
		TCComponentDatasetDefinition tCComponentDatasetDefinition = null;
		NamedReferenceContext[] arrayOfNamedReferenceContext = null;
		try {
			tCComponentDatasetDefinition = this.datasetComponent.getDatasetDefinitionComponent();
			arrayOfNamedReferenceContext = tCComponentDatasetDefinition.getNamedReferenceContexts();
		} catch (Exception exception) {
			MessageBox.post(this.parent, exception);
		}
		if (arrayOfNamedReferenceContext == null || arrayOfNamedReferenceContext.length == 0) {
			MessageBox.post(this.parent, this.appReg.getString("noRefTypeFound"),
					this.appReg.getString("warning.TITLE"), 4);
			return;
		}
		Frame frame = Utilities.getCurrentFrame();
		TCFileSelectorService tCFileSelectorService = TCFileSelectorService.getInstance();
		IFilesSelector iFilesSelector = tCFileSelectorService.getFileSelector();
		if (iFilesSelector == null) {
			ImportFilesFileChooser importFilesFileChooser = new ImportFilesFileChooser(tCComponentDatasetDefinition,
					frame);
			int i = importFilesFileChooser.showDialog(frame, null);
			if (i == 0) {
				final File f = importFilesFileChooser.getSelectedFile();
				if (f != null) {
					String str1 = f.getAbsolutePath();
					final String type = importFilesFileChooser.getType();
					final String ref = importFilesFileChooser.getReferenceType();
					Registry registry = Registry.getRegistry(this);
					if (!DatasetUtil.isValidFileForUpload(tCComponentDatasetDefinition, str1)) {
						MessageBox.post(this.parent, registry.getString("invalidFile.MSG"),
								registry.getString("warning.TITLE"), 4);
						return;
					}
					Utilities.setCookie("filechooser", true, "DatasetImport.DIR", f.getParent());
					if (this.truncateFileName.equalsIgnoreCase("TRUE")) {
						byte b = 30;
						if (f.getName().length() > b) {
							Display.getDefault().asyncExec(new Runnable() {
								@Override
								public void run() {
									String str = NamedReferencesDialog.this.appReg.getString("fileNameTruncated");
									Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
									int i = ConfirmDialog.prompt(shell,
											NamedReferencesDialog.this.appReg.getString("warning.TITLE"), str);
									if (i == 2)
										NamedReferencesDialog.this.executeImportOperation(f, type, ref);
								}
							});
						} else {
							executeImportOperation(f, type, ref);
						}
					} else {
						char c = '';
						if (f.getName().length() > c) {
							StringBuffer stringBuffer = (new StringBuffer(
									this.appReg.getString("fileNameLengthTooLong"))).append(" (").append(c)
											.append(").");
							MessageBox.post(this.parent, stringBuffer.toString(),
									this.appReg.getString("warning.TITLE"), 4);
						} else {
							executeImportOperation(f, type, ref);
						}
					}
				} else {
					MessageBox.post(this.parent, this.appReg.getString("noImportFileSelection"),
							this.appReg.getString("warning.TITLE"), 4);
				}
			}
		} else {
			try {
				logger.debug("Delegating file selection to extensionPointImplementation class: "
						+ iFilesSelector.getClass());
				iFilesSelector.initialize(tCComponentDatasetDefinition, null, null);
				List<TCFileDescriptor> list = iFilesSelector.getSelectedFiles();
				if (list != null && !list.isEmpty()) {
					logger.debug("File descriptor information for files selected by custom code");
					for (TCFileDescriptor tCFileDescriptor1 : list)
						logger.debug(tCFileDescriptor1);
					TCFileDescriptor tCFileDescriptor = list.get(0);
					if (tCFileDescriptor != null) {
						final File f = tCFileDescriptor.getFile();
						if (f != null) {
							Utilities.setCookie("filechooser", true, "DatasetImport.DIR", f.getParent());
						} else {
							logger.error("File object in TCFileDescriptor return by custom code is null");
						}
					} else {
						logger.error(
								"TCFileDescriptor object in List<TCFileDescriptor> returned by custom code is null");
					}
				} else {
					logger.debug(
							"Custom code did not return any information about selected files. Looks like user has not selected any files");
					if (list == null) {
						logger.debug("getSelectedFiles returned null");
					} else {
						logger.debug("getSelectedFiles returned empty list");
					}
				}
				ImportFilesOperation importFilesOperation = new ImportFilesOperation(this.datasetComponent,
						iFilesSelector, null, Utilities.getCurrentFrame());
				this.session.queueOperation(importFilesOperation);
			} catch (Exception exception) {
				MessageBox messageBox = new MessageBox(this.parent, exception);
				messageBox.setModal(true);
				messageBox.setVisible(true);
				return;
			}
		}
	}

	protected void executeImportOperation(File paramFile, String paramString1, String paramString2) {
		ImportFilesOperation importFilesOperation = new ImportFilesOperation(this.datasetComponent, paramFile,
				paramString1, null, paramString2, Utilities.getCurrentFrame());
		this.session.queueOperation(importFilesOperation);
	}

	private void startOpenFileOperation() {
		int[] arrayOfInt = checkTableSelection(false, true);
		if (arrayOfInt == null)
			return;
		Registry registry = Registry.getRegistry("com.teamcenter.rac.common.actions.actions");
		TCComponent tCComponent = this.model.getComponentAt(arrayOfInt[0]);
		if (tCComponent instanceof TCComponentTcFile) {
			String str1 = (String) this.model.getValueAt(arrayOfInt[0], "object_name");
			if (this.selectedToolComponent == null)
				return;
			String str2 = (String) this.model.getValueAt(arrayOfInt[0], "original_file_name");
			AbstractAIFCommand abstractAIFCommand = (AbstractAIFCommand) registry.newInstanceFor("openAsCommand",
					new Object[] { this.datasetComponent, this.selectedToolComponent, str2,
							Utilities.getParentFrame(this) });
			abstractAIFCommand.executeModeless();
		} else if (tCComponent != null) {
			AIFDesktop aIFDesktop = AIFUtility.getActiveDesktop();
			AbstractAIFCommand abstractAIFCommand = (AbstractAIFCommand) registry.newInstanceFor("openCommand",
					new Object[] { aIFDesktop, tCComponent });
			abstractAIFCommand.executeModeless();
		}
	}

	private void startCutNamedRefOperation() {
		int[] arrayOfInt1 = checkTableSelection(true, true);
		if (arrayOfInt1 == null)
			return;
		ArrayList arrayList1 = new ArrayList();
		ArrayList arrayList2 = new ArrayList();
		ArrayList arrayList3 = new ArrayList();
		ArrayList arrayList4 = new ArrayList();
		int[] arrayOfInt2;
		arrayOfInt2 = arrayOfInt1;
		int i = arrayOfInt1.length;
		for (byte b = 0; b < i; b++) {
			int j = arrayOfInt2[b];
			TCComponent tCComponent = this.model.getComponentAt(j);
			if (tCComponent instanceof TCComponentTcFile) {
				arrayList1.add(tCComponent);
				String str1 = (String) this.model.getValueAt(j, "object_name");
				String str2 = (String) this.model.getValueAt(j, "original_file_name");
				arrayList2.add(str1);
				arrayList3.add(str2);
			} else {
				String str = this.model.getNamedRefType(tCComponent);
				if (str == null) {
					MessageBox.post(this.parent,
							String.valueOf(this.appReg.getString("cannotCut")) + " " + tCComponent.toString(),
							this.appReg.getString("warning.TITLE"), 4);
				} else {
					arrayList1.add(tCComponent);
					arrayList4.add(str);
				}
			}
		}
		if (!arrayList1.isEmpty()) {
			int j = arrayList1.size();
			InterfaceAIFComponent[] arrayOfInterfaceAIFComponent = (InterfaceAIFComponent[]) arrayList1
					.toArray(new InterfaceAIFComponent[j]);
			Registry registry = Registry.getRegistry("com.teamcenter.rac.common.actions.actions");
			AbstractAIFCommand abstractAIFCommand = (AbstractAIFCommand) registry.newInstanceFor("copyCommand",
					new Object[] { arrayOfInterfaceAIFComponent });
			abstractAIFCommand.executeModeless();
		}
		try {
			sourceClassificationString = this.datasetComponent.getProperties(this.prop);
		} catch (TCException tCException) {
			MessageBox.post(this.parent, tCException);
		}
		if (!arrayList2.isEmpty()) {
			int j = arrayList2.size();
			String[] arrayOfString1 = (String[]) arrayList2.toArray(new String[j]);
			String[] arrayOfString2 = (String[]) arrayList3.toArray(new String[j]);
			RemoveNamedRefOperation removeNamedRefOperation = new RemoveNamedRefOperation(this.datasetComponent,
					arrayOfString1, arrayOfString2, Utilities.getCurrentFrame());
			this.session.queueOperation(removeNamedRefOperation);
		}
		if (!arrayList4.isEmpty()) {
			int j = arrayList4.size();
			String[] arrayOfString = (String[]) arrayList4.toArray(new String[j]);
			RemoveNamedRefOperation removeNamedRefOperation = new RemoveNamedRefOperation(this.datasetComponent,
					arrayOfString, Utilities.getCurrentFrame());
			this.session.queueOperation(removeNamedRefOperation);
		}
	}

	private void startDeleteNamedRefOperation() {
		int[] arrayOfInt1 = checkTableSelection(true, true);
		if (arrayOfInt1 == null)
			return;
		if (ConfirmationDialog.post((Frame) this.parent, this.appReg.getString("delete.TITLE"),
				this.appReg.getString("delete")) != 2)
			return;
		ArrayList arrayList1 = new ArrayList();
		ArrayList arrayList2 = new ArrayList();
		ArrayList arrayList3 = new ArrayList();
		ArrayList arrayList4 = new ArrayList();
		int[] arrayOfInt2;
		arrayOfInt2 = arrayOfInt1;
		int i = arrayOfInt1.length;
		for (byte b = 0; b < i; b++) {
			int j = arrayOfInt2[b];
			TCComponent tCComponent = this.model.getComponentAt(j);
			if (tCComponent instanceof TCComponentTcFile) {
				arrayList1.add(tCComponent);
				String str1 = (String) this.model.getValueAt(j, "object_name");
				String str2 = (String) this.model.getValueAt(j, "original_file_name");
				arrayList2.add(str1);
				arrayList3.add(str2);
			} else {
				String str = this.model.getNamedRefType(tCComponent);
				if (str == null) {
					MessageBox.post(this.parent,
							String.valueOf(this.appReg.getString("cannotDelete")) + " " + tCComponent.toString(),
							this.appReg.getString("warning.TITLE"), 4);
				} else {
					arrayList1.add(tCComponent);
					arrayList4.add(str);
				}
			}
		}
		if (!arrayList2.isEmpty()) {
			arrayList3.add(":::::::::://////////\\\\\\\\\\");
			arrayList2.add(":::::::::://////////\\\\\\\\\\");
			int j = arrayList2.size();
			String[] arrayOfString1 = (String[]) arrayList2.toArray(new String[j]);
			String[] arrayOfString2 = (String[]) arrayList3.toArray(new String[j]);
			RemoveNamedRefOperation removeNamedRefOperation = new RemoveNamedRefOperation(this.datasetComponent,
					arrayOfString1, arrayOfString2, Utilities.getCurrentFrame());
			this.session.queueOperation(removeNamedRefOperation);
		}
		if (!arrayList4.isEmpty()) {
			int j = arrayList4.size();
			String[] arrayOfString = (String[]) arrayList4.toArray(new String[j]);
			RemoveNamedRefOperation removeNamedRefOperation = new RemoveNamedRefOperation(this.datasetComponent,
					arrayOfString, Utilities.getCurrentFrame());
			this.session.queueOperation(removeNamedRefOperation);
		}
	}

	private void startCopyOperation() {
		int[] arrayOfInt = checkTableSelection(true, true);
		if (arrayOfInt == null)
			return;
		int i = arrayOfInt.length;
		TCComponent[] arrayOfTCComponent = new TCComponent[i];
		for (byte b = 0; b < i; b++) {
			arrayOfTCComponent[b] = this.model.getComponentAt(arrayOfInt[b]);
			arrayOfTCComponent[b].setClientObject(this.model.getValueAt(arrayOfInt[b], "object_name"));
		}
		try {
			sourceClassificationString = this.datasetComponent.getProperties(this.prop);
		} catch (TCException b) {
			TCException tCException;
			MessageBox.post(this.parent, b);
		}
		Registry registry = Registry.getRegistry("com.teamcenter.rac.common.actions.actions");
		AbstractAIFCommand abstractAIFCommand = (AbstractAIFCommand) registry.newInstanceFor("copyCommand",
				new Object[] { arrayOfTCComponent });
		abstractAIFCommand.executeModeless();
	}

	private void startPasteOperation() {
		AIFClipboard aIFClipboard = AIFPortal.getClipboard();
		Transferable transferable = aIFClipboard.getContents(this);
		if (transferable == null) {
			MessageBox.post(this.parent, this.appReg.getString("clipboardEmpty"),
					this.appReg.getString("warning.TITLE"), 4);
			return;
		}
		Vector vector1 = new Vector();
		try {
			vector1 = (Vector) transferable.getTransferData(new DataFlavor(Vector.class, "AIF Vector"));
		} catch (Exception exception) {
			MessageBox.post(this.parent, exception);
			return;
		}
		if (vector1 == null || vector1.isEmpty()) {
			MessageBox.post(this.parent, this.appReg.getString("clipboardEmpty"),
					this.appReg.getString("warning.TITLE"), 4);
			return;
		}
		Vector vector2 = new Vector();
		for (byte b = 0; b < vector1.size(); b++) {
			if (vector1.elementAt(b) instanceof TCComponent)
				vector2.addElement(vector1.elementAt(b));
		}
		try {
			destClassificationString = this.datasetComponent.getProperties(this.prop);
		} catch (TCException b) {
			TCException tCException;
			MessageBox.post(this.parent, b);
		}
		if (sourceClassificationString != null && destClassificationString != null
				&& (!sourceClassificationString[0].equals(destClassificationString[0])
						|| !sourceClassificationString[1].equals(destClassificationString[1]))) {
			MessageBox.post(this.parent, this.appReg.getString("incorrectClassification"),
					this.appReg.getString("error.TITLE"), 1);
			return;
		}
		if (vector2.isEmpty()) {
			MessageBox.post(this.parent, this.appReg.getString("cannotPaste"), this.appReg.getString("warning.TITLE"),
					4);
			return;
		}
		TCComponent[] arrayOfTCComponent = (TCComponent[]) vector2.toArray(new TCComponent[vector2.size()]);
		PasteNamedReferencesDialog pasteNamedReferencesDialog = new PasteNamedReferencesDialog(this.datasetComponent,
				arrayOfTCComponent, Utilities.getCurrentFrame());
		pasteNamedReferencesDialog.setVisible(true);
	}

	private void startModifyFileName(TCComponent paramTCComponent, String paramString) {
		if (paramTCComponent == null || paramString == null || paramString.length() == 0)
			return;
		try {
			String str = paramTCComponent.getProperty("original_file_name");
			if (str.equals(paramString))
				return;
			if (paramTCComponent instanceof TCComponentTcFile) {
				TCComponentTcFile tCComponentTcFile = (TCComponentTcFile) paramTCComponent;
				tCComponentTcFile.setOriginalFileName(this.datasetComponent, paramString);
			} else {
				paramTCComponent.setProperty("object_name", paramString);
				paramTCComponent.firePropertyChangeEvent("object_name");
			}
		} catch (TCException tCException) {
			MessageBox.post(this.parent, tCException);
		}
	}

	private void loadNamedReferences() {
		String str = String.valueOf(this.appReg.getString("loadingNamedRef")) + this.datasetComponent.toString();
		this.session.queueOperation(new AbstractAIFOperation(str) {
			@Override
			public void executeOperation() {
				TCComponent[] arrayOfTCComponent1;
				NamedReferencesDialog.this.tableScrollPane.setCursor(Cursor.getPredefinedCursor(3));
				try {
					arrayOfTCComponent1 = NamedReferencesDialog.this.datasetComponent.getNamedReferences();
					for (byte b = 0; b < arrayOfTCComponent1.length; b++)
						arrayOfTCComponent1[b].clearCache();
				} catch (TCException tCException) {
					MessageBox.post(NamedReferencesDialog.this.parent, tCException);
					NamedReferencesDialog.this.tableScrollPane.setCursor(Cursor.getPredefinedCursor(0));
					return;
				}
				if (arrayOfTCComponent1.length == 0) {
					NamedReferencesDialog.this.tableScrollPane.setCursor(Cursor.getPredefinedCursor(0));
					return;
				}
				final TCComponent[] namedRefsArray = arrayOfTCComponent1;
				Utilities.invokeLater(new Runnable() {
					@Override
					public void run() {
						try {
							NamedReferencesDialog.this.model.removeAllRows();
							TCComponent[] arrayOfTCComponent;
							arrayOfTCComponent = namedRefsArray;
							int i = namedRefsArray.length;
							for (byte b = 0; b < i; b++) {
								TCComponent tCComponent = arrayOfTCComponent[b];
								NamedReferencesDialog.this.model.addRow(tCComponent);
							}
						} catch (Exception exception) {
							MessageBox.post(NamedReferencesDialog.this.parent, exception);
						}
						NamedReferencesDialog.this.tableScrollPane.setCursor(Cursor.getPredefinedCursor(0));
						NamedReferencesDialog.this.tableScrollPane.validate();
						NamedReferencesDialog.this.tableScrollPane.repaint();
						NamedReferencesDialog.this.table.validate();
						NamedReferencesDialog.this.table.repaint();
					}
				});
			}
		});
	}

	@Override
	public void processComponentEvents(AIFComponentEvent[] paramArrayOfAIFComponentEvent) {
		AIFComponentEvent[] arrayOfAIFComponentEvent;
		arrayOfAIFComponentEvent = paramArrayOfAIFComponentEvent;
		int i = paramArrayOfAIFComponentEvent.length;
		for (byte b = 0; b < i; b++) {
			AIFComponentEvent aIFComponentEvent = arrayOfAIFComponentEvent[b];
			if (aIFComponentEvent instanceof com.teamcenter.rac.aif.kernel.AIFComponentChangeEvent) {
				TCComponent tCComponent = (TCComponent) aIFComponentEvent.getComponent();
				if (tCComponent instanceof TCComponentDataset) {
					TCComponentDataset tCComponentDataset = (TCComponentDataset) tCComponent;
					if (tCComponentDataset == this.datasetComponent) {
						Utilities.invokeLater(new Runnable() {
							@Override
							public void run() {
								NamedReferencesDialog.this.model.removeAllRows();
							}
						});
						loadNamedReferences();
						break;
					}
				}
			}
		}
	}

	protected String getDefaultExportDirectory() {
		String str = Utilities.getCookie("filechooser", "DatasetExport.DIR", true);
		if (str == null || str.length() == 0) {
			TCPreferenceService tCPreferenceService = ((TCSession) this.session).getPreferenceService();
			str = tCPreferenceService.getString(0, "defaultExportDirectory");
		}
		if (str != null) {
			str = str.trim();
			if (str.length() == 0)
				str = null;
		}
		return str;
	}

	private void validateButtons() {
		boolean bool = !this.table.getSelectionModel().isSelectionEmpty();
		AIFClipboard aIFClipboard = AIFPortal.getClipboard();
		Transferable transferable = aIFClipboard.getContents(this);
		this.copyButton.setEnabled(bool);
		this.exportButton.setEnabled(bool);
		this.openButton.setEnabled(bool);
		this.cutButton.setEnabled((allowedNameReferenceModification() && bool));
		this.deleteButton.setEnabled((allowedNameReferenceModification() && bool));
		this.pasteButton.setEnabled((allowedNameReferenceModification() && transferable != null));
		this.importButton.setEnabled(allowedNameReferenceModification());
		try {
			if (this.datasetComponent.isTypeOf("FullText")) {
				this.deleteButton.setEnabled(false);
				this.cutButton.setEnabled(false);
				this.importButton.setEnabled(false);
				this.pasteButton.setEnabled(false);
			}
		} catch (Exception exception) {
			MessageBox.post(this.parent, exception);
		}
	}

	private boolean allowedNameReferenceModification() {
		ViewEditHelper viewEditHelper = new ViewEditHelper(this.datasetComponent.getSession());
		return !(!viewEditHelper.isImplicitlyCheckoutable() && !this.datasetComponent.isCheckedOut());
	}

	private class NamedReferencesTableModel extends DefaultTableModel {
		private Vector<TCComponent> compVector = new Vector();

		private AIFIdentifier[] identifiers = null;

		private Hashtable<TCComponent, String> osLastModifiedDateTable = new Hashtable();

		public NamedReferencesTableModel(String[] param1ArrayOfString) {
			Registry registry = Registry.getRegistry(this);
			String[] arrayOfString1 = null;
			String[] arrayOfString2 = null;
			try {
				Cookie cookie = Cookie.getCookie("namedreference", true);
				arrayOfString1 = cookie.getStringArray("columnname");
				arrayOfString2 = cookie.getStringArray("columnwidth");
				cookie.close();
			} catch (Exception exception) {
			}
			if (arrayOfString1 == null || arrayOfString1.length == 0) {
				int j = 7;
				if (param1ArrayOfString != null && param1ArrayOfString.length > 0)
					j = 7 + param1ArrayOfString.length;
				arrayOfString1 = new String[j];
				arrayOfString1[0] = "object_name";
				arrayOfString1[1] = "original_file_name";
				arrayOfString1[2] = "file_size";
				arrayOfString1[3] = "owning_site";
				arrayOfString1[4] = "object_type";
				arrayOfString1[5] = "last_mod_date";
				arrayOfString1[6] = "volume_tag";
				if (param1ArrayOfString != null && param1ArrayOfString.length > 0)
					for (byte b1 = 0; b1 < param1ArrayOfString.length; b1++)
						arrayOfString1[b1 + 7] = param1ArrayOfString[b1];
			} else if (param1ArrayOfString != null && param1ArrayOfString.length > 0) {
				Vector vector = Utilities.convertArrayToVector(arrayOfString1);
				String[] arrayOfString;
				arrayOfString = param1ArrayOfString;
				int j = param1ArrayOfString.length;
				for (byte b1 = 0; b1 < j; b1++) {
					String str = arrayOfString[b1];
					if (!vector.contains(str))
						vector.add(str);
				}
				arrayOfString1 = (String[]) vector.toArray(new String[vector.size()]);
			}
			int i = arrayOfString1.length;
			Integer[] arrayOfInteger = new Integer[i];
			if (arrayOfString2 == null || arrayOfString2.length == 0) {
				for (byte b1 = 0; b1 < i; b1++)
					arrayOfInteger[b1] = null;
			} else {
				for (byte b1 = 0; b1 < i; b1++) {
					if (b1 < arrayOfString2.length) {
						arrayOfInteger[b1] = new Integer(arrayOfString2[b1]);
					} else {
						arrayOfInteger[b1] = null;
					}
				}
			}
			this.identifiers = new AIFIdentifier[i];
			for (byte b = 0; b < i; b++) {
				String str = String.valueOf(arrayOfString1[b]) + ".NAME";
				this.identifiers[b] = new AIFIdentifier(registry.getString(str, arrayOfString1[b]), arrayOfString1[b]);
				if (b < arrayOfInteger.length)
					this.identifiers[b].setClientData(arrayOfInteger[b]);
			}
			setColumnIdentifiers(this.identifiers);
		}

		public AIFIdentifier[] getColumnIdentifiers() {
			return this.identifiers;
		}

		@Override
		public int getColumnCount() {
			return this.identifiers.length;
		}

		@Override
		public int getRowCount() {
			return (this.compVector == null) ? 0 : this.compVector.size();
		}

		@Override
		public String getColumnName(int param1Int) {
			return (String) this.identifiers[param1Int].getColumnName();
		}

		public Object getValueAt(int param1Int, String param1String) {
			String str = "";
			TCComponent tCComponent = getComponentAt(param1Int);
			try {
				if (param1String.equals("object_name")) {
					str = getNamedRefType(tCComponent);
				} else if (param1String.equals("original_file_name")) {
					if (tCComponent instanceof TCComponentTcFile) {
						str = tCComponent.getProperty(param1String);
						if (str.isEmpty())
							str = tCComponent.getProperty("object_string");
					} else {
						str = tCComponent.getProperty("object_name");
					}
				} else if (tCComponent instanceof TCComponentTcFile && param1String.equals("last_mod_date")) {
					TCPreferenceService tCPreferenceService = ((TCSession) NamedReferencesDialog.this.session)
							.getPreferenceService();
					boolean bool = tCPreferenceService.isTrue(4, "Display_OSFile_LMD_for_TCFile");
					if (Debug.isOn("dataset")) {
						Debug.println("Preference [Display_OSFile_LMD_for_TCFile] value [" + bool + "]");
						if (bool) {
							Debug.println("Use OSFile LMD for LMD of TCFile [" + tCComponent.toString() + "]");
						} else {
							Debug.println("Use LMD of TCFile [" + tCComponent.toString() + "]");
						}
					}
					if (this.osLastModifiedDateTable.containsKey(tCComponent)) {
						str = this.osLastModifiedDateTable.get(tCComponent);
					} else {
						if (bool) {
							str = ((TCComponentTcFile) tCComponent).getOSLastModifiedDate();
						} else {
							str = tCComponent.getProperty(param1String);
						}
						this.osLastModifiedDateTable.put(tCComponent, str);
					}
				} else {
					str = tCComponent.getProperty(param1String);
				}
			} catch (TCException tCException) {
				System.out.println(tCException.toString());
			}
			return str;
		}

		@Override
		public Object getValueAt(int param1Int1, int param1Int2) {
			String str = (String) this.identifiers[param1Int2].getColumnId();
			return getValueAt(param1Int1, str);
		}

		public TCComponent getComponentAt(int param1Int) {
			return this.compVector.elementAt(param1Int);
		}

		@Override
		public Class getColumnClass(int param1Int) {
			return getValueAt(0, param1Int).getClass();
		}

		@Override
		public boolean isCellEditable(int param1Int1, int param1Int2) {
			boolean bool = false;
			String str = (String) this.identifiers[param1Int2].getColumnId();
			TCComponent tCComponent = getComponentAt(param1Int1);
			if (str.equals("original_file_name") && tCComponent instanceof TCComponentTcFile) {
				IPropertyPolicyService iPropertyPolicyService = (IPropertyPolicyService) OSGIUtil
						.getService(Activator.getDefault(), IPropertyPolicyService.class);
				try {
					if (fileNamePolicy == null) {
						ObjectPropertyPolicy objectPropertyPolicy = new ObjectPropertyPolicy();
						objectPropertyPolicy.addType(new PolicyType("ImanFile", new String[] { "original_file_name" },
								new String[] { "includeIsModifiable" }));
						fileNamePolicy = iPropertyPolicyService.createPropertyPolicy(objectPropertyPolicy);
					}
					iPropertyPolicyService.setPropertyPolicy(fileNamePolicy);
					TCComponentType.getTCPropertiesViaSOA(tCComponent.getSession(), tCComponent,
							new String[] { "original_file_name" }, false);
					TCProperty tCProperty = tCComponent.getTCProperty("original_file_name");
					if (tCProperty.isModifiable())
						bool = true;
				} catch (TCException tCException) {
					logger.error(tCException.getLocalizedMessage(), tCException);
				} finally {
					iPropertyPolicyService.restorePropertyPolicy();
				}
			}
			return bool;
		}

		@Override
		public void setValueAt(Object param1Object, int param1Int1, int param1Int2) {
			TCComponent tCComponent = getComponentAt(param1Int1);
			NamedReferencesDialog.this.startModifyFileName(tCComponent, (String) param1Object);
			fireTableCellUpdated(param1Int1, param1Int2);
		}

		@Override
		public void removeRow(int param1Int) {
			TCComponent tCComponent = getComponentAt(param1Int);
			if (this.osLastModifiedDateTable.containsKey(tCComponent))
				this.osLastModifiedDateTable.remove(tCComponent);
			this.compVector.removeElementAt(param1Int);
			fireTableRowsDeleted(param1Int, param1Int);
		}

		public void removeAllRows() {
			int i = getRowCount();
			for (byte b = 0; b < i; b++)
				removeRow(0);
		}

		public void addRow(TCComponent param1TCComponent) {
			if (param1TCComponent == null)
				return;
			int i = this.compVector.size();
			this.compVector.addElement(param1TCComponent);
			String[] arrayOfString = { "last_mod_date", "object_name", "owning_site", "object_type", "volume_tag",
					"file_size" };
			arrayOfString = param1TCComponent.getValidPropertyNames(arrayOfString);
			try {
				param1TCComponent.getTCProperties(arrayOfString);
			} catch (TCException tCException) {
				Logger.getLogger(NamedReferencesTableModel.class).error(tCException.getLocalizedMessage(), tCException);
			}
			fireTableRowsInserted(i, i);
		}

		private String getNamedRefType(TCComponent param1TCComponent) {
			String str = "";
			try {
				String[] arrayOfString1 = { "ref_list", "ref_names" };
				TCProperty[] arrayOfTCProperty = NamedReferencesDialog.this.datasetComponent
						.getTCProperties(arrayOfString1);
				TCProperty tCProperty1 = arrayOfTCProperty[0];
				TCProperty tCProperty2 = arrayOfTCProperty[1];
				if (tCProperty1 == null || tCProperty2 == null)
					return str;
				TCComponent[] arrayOfTCComponent = tCProperty1.getReferenceValueArray();
				String[] arrayOfString2 = tCProperty2.getStringValueArray();
				if (arrayOfTCComponent == null || arrayOfString2 == null)
					return str;
				int i = arrayOfTCComponent.length;
				if (i != arrayOfString2.length)
					return str;
				byte b1 = -1;
				for (byte b2 = 0; b2 < i; b2++) {
					if (param1TCComponent == arrayOfTCComponent[b2]) {
						b1 = b2;
						break;
					}
				}
				if (b1 != -1)
					str = arrayOfString2[b1];
			} catch (TCException tCException) {
				return "";
			}
			return str;
		}
	}

	private static class RightTextRenderer extends DefaultTableCellRenderer {
		public RightTextRenderer() {
			setHorizontalAlignment(4);
		}

		@Override
		public Component getTableCellRendererComponent(JTable param1JTable, Object param1Object, boolean param1Boolean1,
				boolean param1Boolean2, int param1Int1, int param1Int2) {
			super.getTableCellRendererComponent(param1JTable, param1Object, param1Boolean1, param1Boolean2, param1Int1,
					param1Int2);
			if (param1Object != null) {
				setText(param1Object.toString());
			} else {
				setText("");
			}
			return this;
		}
	}

	private class ToolSelectedDialog extends AbstractAIFDialog {
		private JButton nextButton;

		private JList toolList;

		private DefaultListModel toolListModel;

		private String namedRef;

		public ToolSelectedDialog(Frame param1Frame, String param1String) {
			super(param1Frame, true);
			this.namedRef = param1String;
			initializeDialog();
		}

		private void initializeDialog() {
			setTitle(NamedReferencesDialog.this.appReg.getString("selectTool.TITLE"));
			JPanel jPanel1 = new JPanel(new VerticalLayout(5, 2, 2, 2, 2));
			getContentPane().add(jPanel1);
			this.toolListModel = new DefaultListModel();
			this.toolList = new JList(this.toolListModel);
			this.toolList.setSelectionMode(0);
			JScrollPane jScrollPane = new JScrollPane(this.toolList);
			JPanel jPanel2 = new JPanel(new VerticalLayout(5, 2, 2, 2, 2));
			JLabel jLabel = new JLabel(NamedReferencesDialog.this.appReg.getString("userWizard"));
			Font font = jLabel.getFont();
			font = new Font(font.getName(), 1, font.getSize());
			jLabel.setFont(font);
			jPanel2.add("top.nobind.left.top", jLabel);
			jPanel2.add("unbound.bind.center.center", jScrollPane);
			JPanel jPanel3 = new JPanel(new HorizontalLayout(15, 2, 2, 2, 2));
			jPanel3.add("left.bind.left.center", new JLabel(
					NamedReferencesDialog.this.appReg.getOverlayImageIcon("stepBackground.ICON", "newForm32.ICON", 1)));
			jPanel3.add("unbound.bind.center.center", jPanel2);
			JPanel jPanel4 = new JPanel();
			jPanel4.setLayout(new ButtonLayout(1, 3, 20));
			this.nextButton = new JButton(NamedReferencesDialog.this.appReg.getString("nextButton"),
					NamedReferencesDialog.this.appReg.getImageIcon("next.ICON"));
			this.nextButton.setHorizontalTextPosition(2);
			this.nextButton.setMnemonic(NamedReferencesDialog.this.appReg.getString("next.MNEMONIC").charAt(0));
			this.nextButton.setEnabled(false);
			this.nextButton.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent param2ActionEvent) {
					NamedReferencesDialog.ToolSelectedDialog.this.doNextOperation();
					NamedReferencesDialog.ToolSelectedDialog.this.disposeDialog();
				}
			});
			this.toolList.addListSelectionListener(new ListSelectionListener() {
				@Override
				public void valueChanged(ListSelectionEvent param2ListSelectionEvent) {
					NamedReferencesDialog.ToolSelectedDialog.this.nextButton.requestFocusInWindow();
				}
			});
			jPanel4.add(this.nextButton);
			jPanel1.add("top.nobind.left.top",
					new JLabel(NamedReferencesDialog.this.appReg.getImageIcon("Tool.ICON"), 0));
			jPanel1.add("top.bind.center.center", new Separator());
			jPanel1.add("unbound.bind.left.center", jPanel3);
			jPanel1.add("bottom.bind.center.center", jPanel4);
			jPanel1.add("bottom.bind.center.center", new Separator());
			loadTools();
			if (NamedReferencesDialog.this.toolComponents == null)
				return;
			if (NamedReferencesDialog.this.toolComponents.length == 1) {
				NamedReferencesDialog.this.selectedToolComponent = NamedReferencesDialog.this.toolComponents[0];
				return;
			}
			this.toolList.setSelectedIndex(0);
			this.nextButton.setEnabled(true);
			setDefaultCloseOperation(0);
			addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent param2WindowEvent) {
					NamedReferencesDialog.this.selectedToolComponent = null;
					NamedReferencesDialog.ToolSelectedDialog.this.disposeDialog();
				}
			});
			pack();
			centerToScreen(1.5D, 1.0D, 0.6D, 0.4D);
			setVisible(true);
		}

		private void loadTools() {
			try {
				NamedReferencesDialog.this.toolComponents = NamedReferencesDialog.this.datasetComponent
						.getDatasetDefinitionComponent().getToolsForNamedRef(this.namedRef, 4);
			} catch (TCException tCException) {
				MessageBox.post(NamedReferencesDialog.this.parent, tCException);
				return;
			}
			if (NamedReferencesDialog.this.toolComponents == null)
				return;
			TCComponent[] arrayOfTCComponent;
			arrayOfTCComponent = NamedReferencesDialog.this.toolComponents;
			int i = NamedReferencesDialog.this.toolComponents.length;
			for (byte b = 0; b < i; b++) {
				TCComponent tCComponent = arrayOfTCComponent[b];
				this.toolListModel.addElement(tCComponent);
			}
			this.toolList.revalidate();
			this.toolList.doLayout();
			this.toolList.repaint();
		}

		private void doNextOperation() {
			NamedReferencesDialog.this.selectedToolComponent = (TCComponent) this.toolList.getSelectedValue();
		}
	}
}

/*
 * Location:
 * E:\work\plugins12_1\com.teamcenter.rac.common_12000.1.0.jar!/com/teamcenter/
 * rac/commands/namedreferences/NamedReferencesDialog.class Java compiler
 * version: 8 (52.0) JD-Core Version: 1.0.7
 */